## openturns 1.7

=== CMakeLists.txt ===
#                                               -*- cmake -*-

cmake_minimum_required (VERSION 2.8)

# By default, build in Release mode. Must appear before project() command
if (NOT DEFINED CMAKE_BUILD_TYPE)
  set(CMAKE_BUILD_TYPE Release CACHE STRING "Build type")
endif ()
if (CMAKE_VERSION VERSION_GREATER 2.8)
  set_property(CACHE CMAKE_BUILD_TYPE PROPERTY STRINGS "" Release Debug RelWithDebInfo MinSizeRel)
endif ()

project (OpenTURNS CXX)

option (USE_BISON                    "Looks for Bison if true and then build parser"                         ON)
option (USE_FLEX                     "Looks for Flex if true and then build lexer"                           ON)
option (USE_TBB                      "Use Intel Threading Building Blocks library for multithreading"        ON)
option (USE_HMAT                     "Use HMat library"                                                      ON)
option (USE_MUPARSER                 "Use muParser libraries"                                                ON)
option (USE_LIBXML2                  "Use LibXml2 for XML support"                                           ON)
option (USE_R                        "Use R for graph output support"                                        ON)
option (USE_OPENMP                   "Use OpenMP for multithreading"                                         OFF)
option (USE_BOOST                    "Use Boost for distribution computation"                                ON)
option (USE_SPHINX                    "Use sphinx for documentation"                                          ON)
option (USE_DOXYGEN                   "Use Doxygen for API documentation"                                     ON)
option (USE_NLOPT                    "Use NLopt for additional optimization algorithms"                      ON)

option (BUILD_LIB                    "Build the library"                                                     ON)
option (BUILD_PYTHON                 "Build the python module for the library"                               ON)
option (BUILD_VALIDATION             "Build the validation files of the library"                             ON)
option (LINK_PYTHON_LIBRARY          "Link python modules against python library"                            ON)
option (INSTALL_TESTS                "Install compiled tests for native platform testing"                    OFF)
option (BUILD_SHARED_LIBS            "Build shared libraries"                                                ON)

if (MSVC)
  option (BUILD_MULTIPROCESSOR       "Enable multiprocessor builds"                                          ON)
endif ()

# Defines our own module path
list (APPEND CMAKE_MODULE_PATH ${CMAKE_SOURCE_DIR}/cmake)


set (OPENTURNS_HOME_ENV_VAR OPENTURNS_HOME    )

if (NOT DEFINED CMAKE_INSTALL_LIBDIR)
  set (CMAKE_INSTALL_LIBDIR lib${LIB_SUFFIX})
endif ()

set (OPENTURNS_LIBRARY_PATH
      ${CMAKE_INSTALL_LIBDIR}
      CACHE PATH "The directory where the library is installed"
   )
set (OPENTURNS_INCLUDE_PATH
      include/openturns
      CACHE PATH "The directory where the header files are installed"
   )
set (OPENTURNS_CONFIG_CMAKE_PATH
      ${CMAKE_INSTALL_LIBDIR}/cmake/openturns
      CACHE PATH "The directory where the CMake files are installed"
   )
set (OPENTURNS_SYSCONFIG_PATH
      etc
      CACHE PATH "The directory where the configuration file is installed"
   )
set (OPENTURNS_DATA_PATH
      share
      CACHE PATH "The directory where the common files are installed"
   )
set (OPENTURNS_EXAMPLE_PATH
      share/openturns/examples
      CACHE PATH "The directory where the example files are installed"
   )
set (OPENTURNS_SAMPLE_PATH
      share/openturns/examples
      CACHE PATH "The directory where the sample files are installed"
   )
set (OPENTURNS_VALIDATION_PATH
      share/openturns/validation
      CACHE PATH "The directory where validation files are installed"
   )
set (OPENTURNS_DOC_PATH
      share/openturns/doc
      CACHE PATH "The directory where the license files are installed"
   )

if (WIN32)
  set (DEFAULT_TMP TEMP)
  set (PATH_SEP "\\;")
else ()
  set(DEFAULT_TMP /tmp)
  set (PATH_SEP ":")
endif()

set (OPENTURNS_TEMPDIR
      ${DEFAULT_TMP}
      CACHE PATH "The directory for temporary files. /tmp by default."
   )
set (TEMPDIR ${OPENTURNS_TEMPDIR})

# WARNING: This is where variables without OPENTURNS_ prefix are defined !
foreach (_var INSTALL_PATH LIBRARY_PATH INCLUDE_PATH CONFIG_CMAKE_PATH SYSCONFIG_PATH DATA_PATH EXAMPLE_PATH SAMPLE_PATH VALIDATION_PATH DOC_PATH)
  file (TO_NATIVE_PATH "${OPENTURNS_${_var}}" NATIVE_OPENTURNS_${_var})
  if (NOT IS_ABSOLUTE ${NATIVE_OPENTURNS_${_var}})
    file (TO_NATIVE_PATH ${CMAKE_INSTALL_PREFIX}/${OPENTURNS_${_var}} NATIVE_OPENTURNS_${_var})
  endif ()
  string(REPLACE "\\" "\\\\" ${_var} ${NATIVE_OPENTURNS_${_var}})
endforeach (_var)

# CMake 2.x does not define MSVC when using Intel compiler on Windows, see
# http://public.kitware.com/Bug/view.php?id=14476
if (WIN32 AND CMAKE_CXX_COMPILER_ID STREQUAL "Intel")
  set(WINTEL TRUE)
endif()


if (BUILD_LIB)

enable_language (C)

if (NOT LAPACKE_FOUND)
  # workaround for cmake issue #0009976
  if (CMAKE_VERSION VERSION_LESS 2.8.4)
    enable_language (Fortran)
  endif ()
  find_package (LAPACK REQUIRED)
  if (LAPACK_FOUND)
    set (OPENTURNS_HAVE_LAPACK TRUE)
    list (APPEND OPENTURNS_LIBRARIES ${LAPACK_LIBRARIES})
  endif ()
endif ()


if (USE_BISON)
  find_package (BISON 2.4)
  if (BISON_FOUND)
    set (OPENTURNS_HAVE_BISON TRUE)
  endif ()
endif ()

if (USE_FLEX)
  find_package (FLEX)
  if (FLEX_FOUND)
    set (OPENTURNS_HAVE_FLEX TRUE)
  endif ()
endif ()

if (USE_TBB)
  find_package (TBB)
endif ()
if (TBB_FOUND)
  set (OPENTURNS_HAVE_TBB_TBB_H TRUE)
  set (OPENTURNS_HAVE_TBB TRUE)
  list (APPEND OPENTURNS_INCLUDE_DIRS ${TBB_INCLUDE_DIRS})
  list (APPEND OPENTURNS_LIBRARIES ${TBB_LIBRARIES})
  if (MSVC OR WINTEL)
    set (OPENTURNS_TBB_NO_IMPLICIT_LINKAGE ON CACHE BOOL "Prevent implicit linkage against tbb.lib ")
  endif ()
endif ()

if (USE_MUPARSER)
  find_package (muParser 1.32)
endif ()
if (MUPARSER_FOUND)
  set (OPENTURNS_HAVE_MUPARSER TRUE)
  list (APPEND OPENTURNS_LIBRARIES ${MUPARSER_LIBRARIES})
  list (APPEND OPENTURNS_PRIVATE_INCLUDE_DIRS ${MUPARSER_INCLUDE_DIRS})
endif ()

if (USE_HMAT)
  find_package (HMAT 1.1 NO_MODULE)
endif ()
if (HMAT_FOUND)
  set (OPENTURNS_HAVE_HMAT TRUE)
  list (APPEND OPENTURNS_LIBRARIES ${HMAT_LIBRARIES})
  list (APPEND OPENTURNS_INCLUDE_DIRS ${HMAT_INCLUDE_DIRS})
endif ()

if (USE_DOXYGEN)
  find_package (Doxygen)
endif ()

if (USE_LIBXML2)
  find_package (LibXml2)
endif ()
if (LIBXML2_FOUND)
  set (OPENTURNS_HAVE_LIBXML2 TRUE)
  list (APPEND OPENTURNS_DEFINITIONS ${LIBXML2_DEFINITIONS})
  list (APPEND OPENTURNS_INCLUDE_DIRS ${LIBXML2_INCLUDE_DIR})
  list (APPEND OPENTURNS_LIBRARIES ${LIBXML2_LIBRARIES})
endif ()

if (MSVC OR WINTEL)
  set (CMAKE_REQUIRED_INCLUDES ${CMAKE_REQUIRED_INCLUDES} ${CMAKE_CURRENT_SOURCE_DIR}/lib/include/pthread_win32 ${CMAKE_CURRENT_SOURCE_DIR}/lib/include)
  include_directories (${PROJECT_SOURCE_DIR}/lib/include/pthread_win32 ${CMAKE_CURRENT_SOURCE_DIR}/lib/include)
endif ()
find_package (Threads)
if (Threads_FOUND)
  list (APPEND OPENTURNS_INCLUDE_DIRS ${THREADS_INCLUDE_DIRS})
  list (APPEND OPENTURNS_LIBRARIES ${CMAKE_THREAD_LIBS_INIT})
endif ()

if (MSVC OR WINTEL)
  set (BOOST_REQUIRED_ARG REQUIRED)
  set (USE_BOOST ON CACHE INTERNAL "Force use of Boost on Windows")
endif ()
if (USE_BOOST)
  # doesn't pass all tests with boost <=1.42 (debian6)
  # but at least pass with 1.46 (ubuntu precise)
  find_package (Boost 1.46 ${BOOST_REQUIRED_ARG})
  if (Boost_FOUND)
    set (OPENTURNS_HAVE_BOOST TRUE)
    list (APPEND OPENTURNS_PRIVATE_INCLUDE_DIRS ${Boost_INCLUDE_DIRS})
  endif ()
endif ()

if (USE_R)
  find_package (R COMPONENTS base rot)
endif ()

if (USE_OPENMP)
  find_package (OpenMP)
  if (OPENMP_FOUND)
    set (CMAKE_CXX_FLAGS "${OpenMP_CXX_FLAGS} ${CMAKE_CXX_FLAGS}")
  endif ()
endif ()

if (USE_NLOPT)
  find_package (NLopt)
  if (NLOPT_FOUND)
    set (OPENTURNS_HAVE_NLOPT TRUE)
    list (APPEND OPENTURNS_PRIVATE_INCLUDE_DIRS ${NLOPT_INCLUDE_DIRS})
    list (APPEND OPENTURNS_LIBRARIES ${NLOPT_LIBRARIES})
  endif ()
endif ()

if (MSVC)
  if (BUILD_MULTIPROCESSOR)
    set (CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} /MP")
  endif ()
  # Disable some warnings
  set (CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} /wd4197 /wd4244 /wd4251 /wd4267 /wd4996")
endif ()

include (TestBigEndian)
test_big_endian (__BIG_ENDIAN__) 

try_compile(OPENTURNS_UNSIGNEDLONG_SAME_AS_UINT64
  ${CMAKE_CURRENT_BINARY_DIR}
  ${CMAKE_CURRENT_SOURCE_DIR}/cmake/unsignedlong_same_as_uint64_t.cxx)

# Find system prerequisites
include (CheckIncludeFile)
check_include_file (assert.h      OPENTURNS_HAVE_ASSERT_H     )
check_include_file (dirent.h      OPENTURNS_HAVE_DIRENT_H     )
check_include_file (errno.h       OPENTURNS_HAVE_ERRNO_H      )
check_include_file (inttypes.h    OPENTURNS_HAVE_INTTYPES_H   )
check_include_file (math.h        OPENTURNS_HAVE_MATH_H       )
check_include_file (pthread.h     OPENTURNS_HAVE_PTHREAD_H    )
check_include_file (signal.h      OPENTURNS_HAVE_SIGNAL_H     )
check_include_file (stdbool.h     OPENTURNS_HAVE_STDBOOL_H    )
check_include_file (stdint.h      OPENTURNS_HAVE_STDINT_H     )
check_include_file (stdlib.h      OPENTURNS_HAVE_STDLIB_H     )
check_include_file (string.h      OPENTURNS_HAVE_STRING_H     )
check_include_file (strings.h     OPENTURNS_HAVE_STRINGS_H    )
check_include_file (sys/stat.h    OPENTURNS_HAVE_SYS_STAT_H   )
check_include_file (sys/time.h    OPENTURNS_HAVE_SYS_TIME_H   )
check_include_file (sys/types.h   OPENTURNS_HAVE_SYS_TYPES_H  )
check_include_file (sys/un.h      OPENTURNS_HAVE_SYS_UN_H     )
check_include_file (unistd.h      OPENTURNS_HAVE_UNISTD_H     )

else ()
  find_package (OpenTURNS NO_MODULE REQUIRED)
endif ()

# Some useful macros to ease CMakeLists.txt file writing
set (SOURCEFILES "" CACHE INTERNAL "List of source files to compile")
macro (ot_add_source_file FILENAME)
  set (sf ${SOURCEFILES} ${CMAKE_CURRENT_SOURCE_DIR}/${FILENAME})
  set (SOURCEFILES ${sf} CACHE INTERNAL "List of source files to compile")
endmacro (ot_add_source_file)

set (BUILT_SOURCEFILES "" CACHE INTERNAL "List of source files to compile")
macro (ot_add_built_source_file FILENAME)
  set (sf ${BUILT_SOURCEFILES} ${FILENAME})
  set (BUILT_SOURCEFILES ${sf} CACHE INTERNAL "List of built source files to compile")
endmacro (ot_add_built_source_file)

set (HEADERFILES "" CACHE INTERNAL "List of header files to install")
macro (ot_install_header_file FILENAME)
  set (hf ${HEADERFILES} ${CMAKE_CURRENT_SOURCE_DIR}/${FILENAME})
  set (HEADERFILES ${hf} CACHE INTERNAL "List of header files to install")
endmacro (ot_install_header_file)

set (SWIGFILES "" CACHE INTERNAL "List of SWIG files to install")
macro (ot_install_swig_file FILENAME)
  set (hf ${SWIGFILES} ${CMAKE_CURRENT_SOURCE_DIR}/${FILENAME})
  set (SWIGFILES ${hf} CACHE INTERNAL "List of SWIG files to install")
endmacro (ot_install_swig_file)

set (INTERNAL_INCLUDE_DIRS "" CACHE INTERNAL "List of directories with header files needed for build")
macro (ot_add_current_dir_to_include_dirs)
  set (inc_dirs ${INTERNAL_INCLUDE_DIRS} ${CMAKE_CURRENT_SOURCE_DIR})
  set (INTERNAL_INCLUDE_DIRS ${inc_dirs} CACHE INTERNAL "List of directories with header files needed for build")
endmacro (ot_add_current_dir_to_include_dirs)
macro (ot_add_build_dir_to_include_dirs DIR)
  set (inc_dirs ${INTERNAL_INCLUDE_DIRS} ${DIR})
  set (INTERNAL_INCLUDE_DIRS ${inc_dirs} CACHE INTERNAL "List of directories with header files needed for build")
endmacro (ot_add_build_dir_to_include_dirs)

list (APPEND OPENTURNS_PRIVATE_LIBRARIES ${CMAKE_CXX_IMPLICIT_LINK_LIBRARIES})
list (APPEND OPENTURNS_PRIVATE_LIBRARIES ${CMAKE_Fortran_IMPLICIT_LINK_LIBRARIES})

# Add definitions according to the prerequisites found
add_definitions(-DHAVE_CONFIG_H)

if (NOT BUILD_SHARED_LIBS)
  list (APPEND OPENTURNS_DEFINITIONS -DOT_STATIC)

=== lib/CMakeLists.txt ===
#                                               -*- cmake -*-

# Recurse in subdirectories
add_subdirectory (include)
add_subdirectory (src)
add_subdirectory (etc)

# Build the OpenTURNSConfig.cmake file
set (OPENTURNS_LIBRARY_DIRS            ${LIBRARY_PATH})
set (OPENTURNS_LIBRARY                 OT)
list (APPEND OPENTURNS_LIBRARIES       ${OPENTURNS_LIBRARY})
set (OPENTURNS_INCLUDE_DIR             ${INCLUDE_PATH})
list (INSERT OPENTURNS_INCLUDE_DIRS 0  ${OPENTURNS_INCLUDE_DIR})

set (OPENTURNS_ROOT_DIR       ${INSTALL_PATH})
set (OPENTURNS_VERSION_STRING ${PACKAGE_VERSION})
set (OPENTURNS_VERSION_MAJOR  ${CPACK_PACKAGE_VERSION_MAJOR})
set (OPENTURNS_VERSION_MINOR  ${CPACK_PACKAGE_VERSION_MINOR})
set (OPENTURNS_VERSION_PATCH  ${CPACK_PACKAGE_VERSION_PATCH})
set (OPENTURNS_USE_FILE       ${CONFIG_CMAKE_PATH}/UseOpenTURNS.cmake)

if(CMAKE_VERSION VERSION_LESS 2.8.8)
  # CMakePackageConfigHelpers is not available
  set (PACKAGE_INIT "
# Generated by a CMake version without CMakePackageConfigHelpers.
macro(set_and_check _var _value)
  set(\${_var} \"\${_value}\")
endmacro(set_and_check _var _value)
"    )
  foreach (_var
      OPENTURNS_USE_FILE
      OPENTURNS_ROOT_DIR
      OPENTURNS_INCLUDE_DIR
      OPENTURNS_INCLUDE_DIRS
      OPENTURNS_LIBRARY_DIRS
      OPENTURNS_SWIG_INCLUDE_DIRS)
    set(PACKAGE_${_var} ${${_var}})
  endforeach ()


  configure_file (OpenTURNSConfig.cmake.in
                   ${CMAKE_CURRENT_BINARY_DIR}/OpenTURNSConfig.cmake
                   @ONLY
                )
                 
  install (FILES UseOpenTURNS.cmake
                  ${CMAKE_CURRENT_BINARY_DIR}/OpenTURNSConfig.cmake
            DESTINATION ${OPENTURNS_CONFIG_CMAKE_PATH}
     )

else (CMAKE_VERSION VERSION_LESS 2.8.8)
  include(CMakePackageConfigHelpers)
  configure_package_config_file (
    OpenTURNSConfig.cmake.in
    ${CMAKE_CURRENT_BINARY_DIR}/OpenTURNSConfig.cmake
    INSTALL_DESTINATION ${OPENTURNS_CONFIG_CMAKE_PATH}
    PATH_VARS
      OPENTURNS_USE_FILE
      OPENTURNS_ROOT_DIR
      OPENTURNS_INCLUDE_DIR
      OPENTURNS_INCLUDE_DIRS
      OPENTURNS_LIBRARY_DIRS
      OPENTURNS_SWIG_INCLUDE_DIRS
    NO_CHECK_REQUIRED_COMPONENTS_MACRO
                               )                   
  write_basic_package_version_file(OpenTURNSConfigVersion.cmake VERSION ${OPENTURNS_VERSION_STRING} COMPATIBILITY AnyNewerVersion)               

  install (FILES UseOpenTURNS.cmake
                  ${CMAKE_CURRENT_BINARY_DIR}/OpenTURNSConfig.cmake
                  ${CMAKE_CURRENT_BINARY_DIR}/OpenTURNSConfigVersion.cmake
            DESTINATION ${OPENTURNS_CONFIG_CMAKE_PATH}
         )
endif (CMAKE_VERSION VERSION_LESS 2.8.8)

# Recurse in subdirectories : test should be run after src (for target OT to be built)
add_subdirectory (test)

if (DOXYGEN_FOUND)

  # generate Doxyfile
  set (VERSION ${PACKAGE_VERSION})
  set (builddir ${CMAKE_CURRENT_BINARY_DIR})
  set ( top_srcdir ${CMAKE_CURRENT_SOURCE_DIR})
  configure_file (${CMAKE_CURRENT_SOURCE_DIR}/Doxyfile.in
                   ${CMAKE_CURRENT_BINARY_DIR}/Doxyfile
                    @ONLY)
                    
  # generate html doc and compress it
  add_custom_target (html 
                      COMMAND ${CMAKE_COMMAND} -E make_directory ${CMAKE_CURRENT_BINARY_DIR}/doc
                      COMMAND ${DOXYGEN_EXECUTABLE} Doxyfile
                      COMMAND tar czf doc-api-${PACKAGE_VERSION}.tar.gz doc
                      COMMAND tar cjf doc-api-${PACKAGE_VERSION}.tar.bz2 doc
                     )                   
                      
endif (DOXYGEN_FOUND)

install (FILES ${HEADERFILES}
          DESTINATION ${INCLUDE_PATH}
       )

=== validation/CMakeLists.txt ===
#                                               -*- cmake -*-

add_subdirectory (src)

=== distro/windows/Makefile ===
#
# Compile and create OpenTURNS installer for windows
#
# Rules dependencies make things done in the right order, however it does not
# detect if OpenTURNS sources has changed. This has to be specified manually:
# - to recompute a rules, remove the corresponding file
#   i.e. some OpenTURNS .cxx have changed:
#     rm ot-compile; make
# - to recompute every rules: make clean; make
#

###############################################################################
# adapt these following lines to your configuration :

# compiler prefix
ARCH=i686
TARGET = $(ARCH)-w64-mingw32

# OpenTurns paths
OT_SRC    ?= $(PWD)/../..
OT_BUILD  ?= $(OT_SRC)/build-$(TARGET)
OT_PREFIX ?= $(OT_BUILD)/install

OT_VERSION ?= $(shell cat ../../VERSION)

WINDEPS = $(PWD)/openturns-developers-windeps-$(OT_VERSION)

# Wine
WINE_PREFIX = $(WINDEPS)/wine-$(ARCH)
export WINEPREFIX = $(WINE_PREFIX)
ifeq ($(ARCH), i686)
export WINEARCH = win32
else
export WINEARCH = win64
endif

MINGW_PREFIX = $(WINDEPS)/mingw-w64-x86_64/usr

# Python
PYBASEVER = 2.7
PYBASEVER_NODOT = $(shell echo $(PYBASEVER) | sed "s|\.||g")
PYTHON_EXECUTABLE=$(MINGW_PREFIX)/$(TARGET)/bin/python$(PYBASEVER_NODOT).exe
export PYTHONHOME := $(MINGW_PREFIX)/$(TARGET)
export PYTHONPATH := $(MINGW_PREFIX)/$(TARGET)/lib/python$(PYBASEVER_NODOT)


R_PATH = $(WINDEPS)/opt/R-2.12.0
PATH := $(R_PATH)/bin:$(PATH)
CMAKE=cmake


# launch OpenTURNS checktests before creating the installer (y,n)
CHECK_OT=y

# build and install tests
INSTALL_TESTS_OPT=ON

JOBS=$(shell getconf _NPROCESSORS_ONLN)
JOBS_PYTHON=$(JOBS)
JOBS_TEST=$(JOBS)
export PATH := $(MINGW_PREFIX)/bin:$(PATH)

DEBUG_OT=n


###############################################################################
# rules:

.PHONY: all clean-python clean mrproper


all: ot-installer


ot-check-compiler:
	@echo -n "Check OpenTURNS dependencies: " 
	@ls $(OT_SRC) $(PYTHON_EXECUTABLE) > /dev/null
	@echo "ok"
	touch ot-check-compiler


ot-config: ot-check-compiler
	-mkdir -p $(OT_BUILD)
	cp $(MINGW_PREFIX)/share/mingw/toolchain-$(TARGET).cmake $(OT_BUILD)
	echo "set(CMAKE_FIND_ROOT_PATH $(MINGW_PREFIX)/$(TARGET))" >> $(OT_BUILD)/toolchain-$(TARGET).cmake
	cp $(MINGW_PREFIX)/$(TARGET)/bin/python$(PYBASEVER_NODOT).dll $(OT_BUILD)
	cd $(OT_BUILD) && rm -f CMakeCache.txt && $(CMAKE) \
	  -DCMAKE_TOOLCHAIN_FILE=toolchain-$(TARGET).cmake \
	  -DCMAKE_BUILD_TYPE=RelWithDebInfo \
	  -DCMAKE_C_FLAGS_RELWITHDEBINFO="-O2 -g -pipe -Wall -Wp,-D_FORTIFY_SOURCE=2 -fexceptions --param=ssp-buffer-size=4" \
	  -DCMAKE_CXX_FLAGS_RELWITHDEBINFO="-O2 -g -pipe -Wall -Wp,-D_FORTIFY_SOURCE=2 -fexceptions --param=ssp-buffer-size=4" \
	  -DPYTHON_INCLUDE_DIR=$(MINGW_PREFIX)/$(TARGET)/include/python$(PYBASEVER_NODOT) \
	  -DPYTHON_INCLUDE_DIR2=$(MINGW_PREFIX)/$(TARGET)/include/python$(PYBASEVER_NODOT) \
	  -DPYTHON_LIBRARY=$(MINGW_PREFIX)/$(TARGET)/lib/libpython$(PYBASEVER_NODOT).dll.a \
	  -DPYTHON_EXECUTABLE=$(PYTHON_EXECUTABLE) \
	  -DR_EXECUTABLE=$(R_PATH)/bin/R.exe \
	  -DCMAKE_INSTALL_PREFIX=$(OT_PREFIX) \
	  -DINSTALL_TESTS=$(INSTALL_TESTS_OPT) \
	  -DUSE_TBB=OFF \
	  -DUSE_SPHINX=OFF \
	  $(OT_SRC)
	touch ot-config

ot-compile: ot-config
	cd $(OT_BUILD)/lib && make -j$(JOBS)
	cd $(OT_BUILD) && make -j$(JOBS_PYTHON)
	-beep
	touch ot-compile

ot-install: ot-compile
	cd $(OT_BUILD) && make install -j$(JOBS)
ifeq ($(DEBUG_OT),n)
	$(TARGET)-strip --strip-unneeded $(OT_PREFIX)/bin/*.dll
	$(TARGET)-strip -g $(OT_PREFIX)/lib/*.a
	$(TARGET)-strip --strip-unneeded $(OT_PREFIX)/Lib/site-packages/*/*.pyd
ifeq ($(INSTALL_TESTS_OPT),ON)
	$(TARGET)-strip --strip-all $(OT_PREFIX)/share/openturns/examples/*.exe
endif
endif
	cp $(MINGW_PREFIX)/$(TARGET)/bin/libgcc_s_*-1.dll $(OT_PREFIX)/bin
	cp $(MINGW_PREFIX)/$(TARGET)/bin/libquadmath-0.dll $(OT_PREFIX)/bin
	cp $(MINGW_PREFIX)/$(TARGET)/bin/libgfortran-3.dll $(OT_PREFIX)/bin
	cp $(MINGW_PREFIX)/$(TARGET)/bin/libstdc++-6.dll $(OT_PREFIX)/bin
	cp $(MINGW_PREFIX)/$(TARGET)/bin/libwinpthread-1.dll $(OT_PREFIX)/bin
	cp $(MINGW_PREFIX)/$(TARGET)/bin/libblas.dll $(OT_PREFIX)/bin
	cp $(MINGW_PREFIX)/$(TARGET)/bin/liblapack.dll $(OT_PREFIX)/bin
	cp $(MINGW_PREFIX)/$(TARGET)/bin/libiconv-2.dll $(OT_PREFIX)/bin
	cp $(MINGW_PREFIX)/$(TARGET)/bin/libxml2-2.dll $(OT_PREFIX)/bin
	cp $(MINGW_PREFIX)/$(TARGET)/bin/*muparser*.dll $(OT_PREFIX)/bin
	cp $(MINGW_PREFIX)/$(TARGET)/bin/zlib1.dll $(OT_PREFIX)/bin
	cp $(MINGW_PREFIX)/$(TARGET)/bin/libnlopt-0.dll $(OT_PREFIX)/bin
# 	cp $(MINGW_PREFIX)/$(TARGET)/bin/libtbb.dll $(OT_PREFIX)/bin
	cp $(MINGW_PREFIX)/$(TARGET)/bin/libgomp-1.dll $(OT_PREFIX)/bin
	cp $(MINGW_PREFIX)/$(TARGET)/bin/libcblas.dll $(OT_PREFIX)/bin
	cp $(MINGW_PREFIX)/$(TARGET)/bin/libhmat-oss.dll $(OT_PREFIX)/bin
	-beep -r 2
	touch ot-install

ot-test: ot-install
	cd $(OT_BUILD) && make tests -j$(JOBS)
ifeq ($(CHECK_OT),y)
	cp $(OT_PREFIX)/bin/*.dll $(OT_BUILD)/lib/test
	cp $(OT_PREFIX)/bin/*.dll $(OT_BUILD)/python/test
	cp $(MINGW_PREFIX)/$(TARGET)/bin/python$(PYBASEVER_NODOT).dll $(OT_BUILD)/python/test
	cd $(OT_BUILD) && ctest -j$(JOBS_TEST) --timeout 1500
	touch ot-test
endif

ot-check-installer: ot-test
	@echo -n "Check OpenTURNS prefix: "
	@ls $(OT_PREFIX) > /dev/null
	@echo "ok"
	@echo -n "Check nsis compiler: "
	@makensis -VERSION > /dev/null 2>&1
	@echo "ok"
	@echo "OpenTURNS installer dependencies seems all right."
	touch ot-check-installer

ot-module-installer: ot-check-installer
	makensis -DOPENTURNS_PREFIX=$(OT_PREFIX) -DPRODUCT_VERSION=$(OT_VERSION) -DPYBASEVER=$(PYBASEVER) -DPYBASEVER_NODOT=$(PYBASEVER_NODOT) -DARCH=$(ARCH) openturns.nsi
	touch ot-module-installer


ot-dev-installer: ot-check-installer
	makensis -DOPENTURNS_PREFIX=$(OT_PREFIX) -DPRODUCT_VERSION=$(OT_VERSION) -DPYBASEVER=$(PYBASEVER) -DPYBASEVER_NODOT=$(PYBASEVER_NODOT) -DARCH=$(ARCH) openturns_developer.nsi
	touch ot-dev-installer


ot-installer: ot-module-installer ot-dev-installer
	-beep -r 3


clean:
	-rm -f ot-*
	-cd $(OT_BUILD) && make clean


mrproper:
	-rm -f ot-*
	-rm -rf $(OT_PREFIX) $(OT_BUILD)
	-rm -f *.exe


VCBOTTLE = $(PWD)/bottle-vc10
OT_BUILD_VC ?= $(OT_SRC)/build-vc

ot-vc:
	-mkdir -p $(OT_BUILD_VC)
	cd $(OT_BUILD_VC) && rm -f CMakeCache.txt && $(VCBOTTLE)/vc-cmake \
	  -DBUILD_PYTHON=OFF \
	  -DUSE_DOXYGEN=OFF \
	  -DUSE_BISON=OFF \
	  -DUSE_FLEX=OFF \
	  -DUSE_TBB=OFF \
	  -DUSE_HMAT=OFF \
	  -DUSE_MUPARSER=OFF \
	  -DUSE_LIBXML2=OFF \
	  -DUSE_R=OFF \
	  -DUSE_NLOPT=OFF \
	  -DBOOST_ROOT=\"C:\\local\\\\boost_1_58_0\" \
	  -DCMAKE_SHARED_LINKER_FLAGS_RELEASE:STRING=\"/OPT:NOREF /INCREMENTAL:NO\" \
	  -DLAPACKE_FOUND=TRUE \
	  -DOPENTURNS_LIBRARIES=\"C:\\local\\OpenBLAS-v0.2.14-Win32\\lib\\libopenblas.dll.a\" \
	  -Dot_configure_date=\"now\" \
	$(OT_SRC)
	cd $(OT_BUILD_VC) && $(VCBOTTLE)/vc-make OT -j$(JOBS)
	cd $(OT_BUILD_VC) && $(VCBOTTLE)/vc-make t_NumericalPoint_std t_ComparisonOperator_std t_Interval_std t_RandomGenerator_std t_Combinations_std t_Mesh_std t_Arcsine_std
	cp $(OT_BUILD_VC)/lib/src/OT.dll $(OT_BUILD_VC)/lib/test
	cp $(VCBOTTLE)/drive_c/local/OpenBLAS-v0.2.14-Win32/bin/libopenblas.dll $(OT_BUILD_VC)/lib/test
	cp $(MINGW_PREFIX)/i686-w64-mingw32/bin/libquadmath-0.dll $(OT_BUILD_VC)/lib/test
	cp $(MINGW_PREFIX)/i686-w64-mingw32/bin/libgcc_s_sjlj-1.dll $(OT_BUILD_VC)/lib/test
	cp $(MINGW_PREFIX)/i686-w64-mingw32/bin/libwinpthread-1.dll $(OT_BUILD_VC)/lib/test
	cp $(MINGW_PREFIX)/i686-w64-mingw32/bin/libgfortran-3.dll $(OT_BUILD_VC)/lib/test
	for testname in `find $(OT_BUILD_VC)/lib/test -name "*.exe"|sed "s|.*/t_\(.*\)\.exe|\1|"`; do \
	  cd $(OT_BUILD_VC)/lib/test && echo "Test: $$testname" && OPENTURNS_CONFIG_PATH=$(OT_BUILD_VC)/lib/etc ./t_$$testname.exe | tr -d '\015' > t_$$testname.out && diff -u $(OT_SRC)/lib/test/t_$$testname.expout t_$$testname.out && echo "Test Passed" || echo "Test Failed"; \
	done
	touch ot-vc

=== lib/include/CMakeLists.txt ===
#                                               -*- cmake -*-

if (CMAKE_Fortran_COMPILER_WORKS)
  # workaround for bug #0014358
  if (CMAKE_VERSION VERSION_LESS 2.8.13 AND NOT DEFINED FortranCInterface_EXE)
    set (FortranCInterface_EXE ${CMAKE_BINARY_DIR}/CMakeFiles/FortranCInterface/FortranCInterface${CMAKE_EXECUTABLE_SUFFIX})
  endif ()

  include (FortranCInterface)
  FortranCInterface_HEADER (FortranCInterface.h)
endif ()

ot_add_current_dir_to_include_dirs ()
ot_add_build_dir_to_include_dirs (${CMAKE_CURRENT_BINARY_DIR})

configure_file (${CMAKE_CURRENT_SOURCE_DIR}/OTconfig.h.in
                 ${CMAKE_CURRENT_BINARY_DIR}/OTconfig.h
                @ONLY
              )

configure_file (${CMAKE_CURRENT_SOURCE_DIR}/installed-OTconfig.h.in
                 ${CMAKE_CURRENT_BINARY_DIR}/installed-OTconfig.h
                @ONLY
              )

set (ot_configure_args)
if (NOT ot_configure_date)
  if (UNIX)
    execute_process (COMMAND date "+%a, %d %b %Y %H:%M:%S %z"
                      OUTPUT_VARIABLE ot_configure_date
                      OUTPUT_STRIP_TRAILING_WHITESPACE
                   )
  elseif(MSVC OR WINTEL)
    execute_process (COMMAND cmd " /C date /T"
                      OUTPUT_VARIABLE ot_configure_date
                      OUTPUT_STRIP_TRAILING_WHITESPACE)
  endif()
  set (ot_configure_date "${ot_configure_date}" CACHE STRING "First configure date.")
endif ()
if (NOT ot_revision)
  execute_process (COMMAND git rev-parse --short HEAD
                    WORKING_DIRECTORY ${CMAKE_SOURCE_DIR}
                    OUTPUT_VARIABLE ot_revision
                    OUTPUT_STRIP_TRAILING_WHITESPACE
                 )
  set (ot_revision "${ot_revision}" CACHE STRING "Revision number.")
endif ()
mark_as_advanced(ot_configure_date ot_revision)
set (prefix ${CMAKE_INSTALL_PREFIX})
set (PACKAGE openturns)

configure_file(${CMAKE_CURRENT_SOURCE_DIR}/OTconfigure_args.hxx.in
                ${CMAKE_CURRENT_BINARY_DIR}/OTconfigureArgs.hxx
                @ONLY
             )

install (FILES OTconfig.hxx
                OTdebug.h
                OTmemory.hxx
                OTprivate.hxx
                OTtestcode.hxx
                OTthread.hxx
                OTtypes.hxx
                OTwindows.h
          DESTINATION ${OPENTURNS_INCLUDE_PATH}
       )
install (FILES ${CMAKE_CURRENT_BINARY_DIR}/installed-OTconfig.h
          DESTINATION ${OPENTURNS_INCLUDE_PATH}
          RENAME OTconfig.h
       )

if (MSVC OR WINTEL)
    install (FILES pthread_win32/pthread.h
                    pthread_win32/semaphore.h
                    pthread_win32/unistd.h
              DESTINATION ${OPENTURNS_INCLUDE_PATH}
           )
endif ()

=== lib/src/CMakeLists.txt ===
#                                               -*- cmake -*-

# Register current directory files
ot_add_current_dir_to_include_dirs ()
ot_install_header_file (OT.hxx)
ot_add_source_file (openturns_library_ok.c)

foreach (include_dir ${OPENTURNS_INCLUDE_DIRS})
  set (EXTRA_CPPFLAGS "${EXTRA_CPPFLAGS} -I${include_dir}")
endforeach ()
configure_file (${CMAKE_CURRENT_SOURCE_DIR}/openturns-config-build.in
                 ${CMAKE_CURRENT_BINARY_DIR}/openturns-config-build
                 @ONLY
              )
set (prefix "${CMAKE_INSTALL_PREFIX}")
set (exec_prefix "${CMAKE_INSTALL_PREFIX}")
set (libdir "${INSTALL_PATH}/lib${LIB_SUFFIX}")
set (PACKAGE "${CPACK_PACKAGE_NAME}")
install (PROGRAMS ${CMAKE_CURRENT_BINARY_DIR}/openturns-config-build
          DESTINATION ${INSTALL_PATH}/bin
          RENAME openturns-config
       )

# Recurse in subdirectories
add_subdirectory (Base)
add_subdirectory (Uncertainty)

# Build main library
foreach (built_source ${BUILT_SOURCEFILES})
  set_source_files_properties (${built_source} PROPERTIES GENERATED TRUE)
endforeach (built_source)
include_directories (${INTERNAL_INCLUDE_DIRS})
link_directories (${CMAKE_Fortran_IMPLICIT_LINK_DIRECTORIES})
add_library (OT ${SOURCEFILES} ${BUILT_SOURCEFILES})

if (BUILD_SHARED_LIBS)
  set_target_properties(OT PROPERTIES COMPILE_DEFINITIONS "OT_DLL_EXPORTS")
endif ()

# soversion
if (NOT DEFINED LIB_VERSION) 
  set (LIB_VERSION 0.0.0)
endif ()
if (NOT DEFINED LIB_SOVERSION) 
  set (LIB_SOVERSION 0)
endif ()
set_target_properties (OT PROPERTIES SOVERSION ${LIB_SOVERSION})
set_target_properties (OT PROPERTIES VERSION ${LIB_VERSION})

if (BISON_FOUND AND FLEX_FOUND)
  add_dependencies (OT generate_csv_lexer)
  add_dependencies (OT generate_csv_parser)
endif ()

target_link_libraries (OT ${OPENTURNS_LIBRARIES})
target_link_libraries (OT ${OPENTURNS_PRIVATE_LIBRARIES})

# Build an empty executable to check link dependencies and completeness
add_executable (linktest main.cxx)
target_link_libraries (linktest OT)
set_target_properties (linktest PROPERTIES
                                 INSTALL_RPATH "${CMAKE_INSTALL_RPATH};${CMAKE_BINARY_DIR}/lib/src")

# Add targets to the build-tree export set
export(TARGETS OT FILE "${PROJECT_BINARY_DIR}/OpenTURNS-Targets.cmake")

# Install the export set for use with the install-tree
install(EXPORT OpenTURNS-Targets DESTINATION
  "${OPENTURNS_CONFIG_CMAKE_PATH}"
    COMPONENT    Development)

# Install rules for library and executable
install (TARGETS OT
          EXPORT  OpenTURNS-Targets
          RUNTIME DESTINATION bin
          LIBRARY DESTINATION ${LIBRARY_PATH}
          ARCHIVE DESTINATION ${LIBRARY_PATH}
       )

if (UNIX AND BUILD_SHARED_LIBS)
  set (OT_GDB_PY ${CMAKE_SHARED_LIBRARY_PREFIX}OT${CMAKE_SHARED_LIBRARY_SUFFIX}.${LIB_VERSION}-gdb.py)
  execute_process (COMMAND ${CMAKE_COMMAND} -E create_symlink ${CMAKE_CURRENT_SOURCE_DIR}/libOT-gdb.py ${CMAKE_CURRENT_BINARY_DIR}/${OT_GDB_PY})
  install (FILES libOT-gdb.py DESTINATION ${OPENTURNS_DATA_PATH}/gdb/auto-load/${LIBRARY_PATH} RENAME ${OT_GDB_PY})
endif ()

=== lib/test/CMakeLists.txt ===
#                                               -*- cmake -*-
#
#  CMakeLists.txt
#
#  Copyright 2005-2015 Airbus-EDF-IMACS-Phimeca
#
#  This library is free software: you can redistribute it and/or modify
#  it under the terms of the GNU Lesser General Public License as published by
#  the Free Software Foundation, either version 3 of the License, or
#  (at your option) any later version.
#
#  This library is distributed in the hope that it will be useful,
#  but WITHOUT ANY WARRANTY; without even the implied warranty of
#  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#  GNU Lesser General Public License for more details.
#
#  You should have received a copy of the GNU Lesser General Public
#  along with this library.  If not, see <http://www.gnu.org/licenses/>.
#
#

set (NEW_PATH "${INSTALL_DESTDIR}${EXAMPLE_PATH}${PATH_SEP}$ENV{PATH}")

set (ADAPT_CHECK_TESTS_EXPONENT)
set (REPLACE_EOL " | cat ")
if (MINGW)
  # replace dos eols
  set (REPLACE_EOL " | tr -d '\\\\015' ")
  # By default, Mingw-g++ puts 3 digits to real exponent whereas g++ puts 2.
  set (ADAPT_CHECK_TESTS_EXPONENT "PRINTF_EXPONENT_DIGITS=2")

  if (CMAKE_SIZEOF_VOID_P EQUAL 4)
    add_library (CRT_fp8 STATIC CRT_fp8.c)
  endif ()
endif ()

set (CHECK_ENVIRONMENT "OPENTURNS_CONFIG_PATH=${CMAKE_BINARY_DIR}/lib/etc"
                        "LD_LIBRARY_PATH=$ENV{LD_LIBRARY_PATH}"
                        ${ADAPT_CHECK_TESTS_EXPONENT} 
   )


set (EXCLUDE_TEST EXCLUDE_FROM_ALL)
if (INSTALL_TESTS)
  set (EXCLUDE_TEST "")

  macro (create_check_file FILE_NAME)
    file (WRITE ${FILE_NAME} "#!/bin/sh\n\n")
    file (APPEND ${FILE_NAME} "#set -e\n\n")
    #file (APPEND ${FILE_NAME} "#${CHECK_ENVIRONMENT}\n\n")
    file (APPEND ${FILE_NAME} "export PRINTF_EXPONENT_DIGITS=2\n")
    file (APPEND ${FILE_NAME} "export AUTOTEST_PATH=$PWD\n")
    file (APPEND ${FILE_NAME} "export OPENTURNS_CONFIG_PATH=$PWD/..\n")
    file (APPEND ${FILE_NAME} "#export OPENTURNS_LOG_SEVERITY=ALL\n")
    file (APPEND ${FILE_NAME} "DEBUG_FILE=stdouterr.dbg \n")
    file (APPEND ${FILE_NAME} "PATH=$PWD:$PWD/..:$PATH\n")
    file (APPEND ${FILE_NAME} "FAILED_TEST=\"\"\n\n")
    file (APPEND ${FILE_NAME} "function check_error {\nif [ \"$?\" != \"0\" ]; then\n  FAILED_TEST=\"$FAILED_TEST $1\"\n  echo \"std_err output:\"\n  cat $DEBUG_FILE\n  echo \"Test #$1: $2 failed!\"\n  echo\nfi\n}\n\n")
  endmacro (create_check_file FILE_NAME)

  macro (add_check_file FILE_NAME TESTNAME EXTERNAL_COMMAND CUR_CHECK)
    file (APPEND ${FILE_NAME} "echo \"Test #${CUR_CHECK}/$NB_CHECK: ${TESTNAME}\"\n")
    file (APPEND ${FILE_NAME} "${EXTERNAL_COMMAND}\n")
    file (APPEND ${FILE_NAME} "check_error ${CUR_CHECK} ${TESTNAME}\n\n")
  endmacro (add_check_file FILE_NAME TESTNAME EXTERNAL_COMMAND CUR_CHECK)

  macro (finish_check_file FILE_NAME NB_CHECK)
    file (APPEND ${FILE_NAME} "}\n\n")
    file (APPEND ${FILE_NAME} "NB_CHECK=${NB_CHECK}\n")
    file (APPEND ${FILE_NAME} "start_tests\necho\n")
    file (APPEND ${FILE_NAME} "RC=0\nif [ \"$FAILED_TEST\" = \"\" ]; then\n  echo \"Every check tests are OK.\"\n")
    file (APPEND ${FILE_NAME} "else\n  echo \"Tests$FAILED_TEST failed!\"\n  RC=1\nfi\n")
    file (APPEND ${FILE_NAME} "exit $RC\n")
  endmacro (finish_check_file FILE_NAME)

  # create a standalone sh file that can launch tests
  set (EXTERNAL_CHECK_FILE "${CMAKE_CURRENT_BINARY_DIR}/start_check_test.sh")
  create_check_file (${EXTERNAL_CHECK_FILE})
  file (APPEND ${EXTERNAL_CHECK_FILE} "\nstart_tests() {\n")
  set (CUR_CHECK 0)
  
endif ()

  
# This macro compiles on the fly and run the corresponding pre-installation test
# It can have two optional arguments PRE and POST followed by some shell command to be run
# before or after the test if needed
# PRE and POST options cn be repeated many times: the arguments will be run one after the other
# in the order of appearence. If one fails, the whole command fails.
set (CHECK_TO_BE_RUN)
macro (ot_check_test TESTNAME)
  set (TESTNAME_TGT t_${TESTNAME})
  set (TESTNAME_SRC ${TESTNAME_TGT}.cxx)
  set (TESTNAME_SRCS ${TESTNAME_SRC})
  add_executable (${TESTNAME_TGT} ${EXCLUDE_TEST} ${TESTNAME_SRCS})
  add_dependencies(tests ${TESTNAME_TGT}) 
  target_link_libraries (${TESTNAME_TGT} OT)
  if (MINGW AND CMAKE_SIZEOF_VOID_P EQUAL 4)
    target_link_libraries (${TESTNAME_TGT} CRT_fp8)
  endif ()
  set_target_properties (${TESTNAME_TGT} PROPERTIES
                                          INSTALL_RPATH "${CMAKE_BINARY_DIR}/lib/src;${CMAKE_INSTALL_RPATH}")
  set (TESTNAME_LOC ${CMAKE_CURRENT_BINARY_DIR}/${TESTNAME_TGT}${CMAKE_EXECUTABLE_SUFFIX})

  set (_CMD)
  set (_PRE)
  set (_POST)
  set (_PARAMS)
  set (_IGNOREOUT OFF)
  foreach (_ARG ${ARGN})
    string (TOUPPER ${_ARG} ARG)
    if (${ARG} MATCHES PRE)
      set (_CMD PRE)
    elseif (${ARG} MATCHES POST)
      set (_CMD POST)
    elseif (${ARG} MATCHES PARAMS)
      set (_CMD PARAMS)
    elseif (${ARG} MATCHES IGNOREOUT)
      set (_IGNOREOUT ON)
    else (${ARG} MATCHES PRE)
      if (${_CMD} MATCHES PRE)
        set (_PRE "${_PRE} ${_ARG} && ")
      elseif (${_CMD} MATCHES POST)
        set (_POST "${_POST} && ${_ARG}")
      elseif (${_CMD} MATCHES PARAMS)
        set (_PARAMS "${_PARAMS} ${_ARG}")
      endif  (${_CMD} MATCHES PRE)
      set (_CMD)
    endif (${ARG} MATCHES PRE)
  endforeach (_ARG)

  if (_IGNOREOUT)
    set (COMMAND "(${TESTNAME_LOC} ${_PARAMS} > /dev/null)")
    set (EXTERNAL_COMMAND "./${TESTNAME_TGT} ${_PARAMS} > $DEBUG_FILE 2>&1")
  else (_IGNOREOUT)
    set (TESTNAME_OUT ${TESTNAME_TGT}.expout)
    set (OUTFILE_LOC ${CMAKE_CURRENT_SOURCE_DIR}/${TESTNAME_OUT})
    set (COMMAND "(${TESTNAME_LOC} ${_PARAMS} ${REPLACE_EOL} > ${CMAKE_CURRENT_BINARY_DIR}/${TESTNAME_TGT}.out) && diff -u ${OUTFILE_LOC} ${CMAKE_CURRENT_BINARY_DIR}/${TESTNAME_TGT}.out")
    set (EXTERNAL_COMMAND "(./${TESTNAME_TGT} ${_PARAMS} 2>$DEBUG_FILE | tr -d '\\\\r' > ${TESTNAME_TGT}.out) && diff -u ${TESTNAME_OUT} ${TESTNAME_TGT}.out")
  endif (_IGNOREOUT)

  if (_PRE OR _POST)
    set (COMMAND "${_PRE}${COMMAND}${_POST}")
    set (EXTERNAL_COMMAND "${_PRE}${EXTERNAL_COMMAND}${_POST}")
  endif (_PRE OR _POST)

  add_test (cppcheck_${TESTNAME} "sh" "-c" "${COMMAND}")
  set_tests_properties (cppcheck_${TESTNAME} PROPERTIES ENVIRONMENT "${CHECK_ENVIRONMENT}")
  list (APPEND CHECK_TO_BE_RUN ${TESTNAME_TGT})
  install (FILES ${TESTNAME_SRC}
            DESTINATION ${EXAMPLE_PATH} 
         )

  if (INSTALL_TESTS)
    install (FILES ${TESTNAME_OUT}
              DESTINATION ${EXAMPLE_PATH} 
           )
    install (TARGETS ${TESTNAME_TGT}
              DESTINATION ${EXAMPLE_PATH} 
           )

    add_check_file (${EXTERNAL_CHECK_FILE} ${TESTNAME_TGT} ${EXTERNAL_COMMAND} ${CUR_CHECK})
    math(EXPR CUR_CHECK "${CUR_CHECK} + 1")
  endif ()

endmacro (ot_check_test)


include_directories (${INTERNAL_INCLUDE_DIRS})

## Pre-installation tests

# Common
ot_check_test (Object_std)
ot_check_test (OStream_std)
ot_check_test (PersistentObject_std)
ot_check_test (Pointer_std)
ot_check_test (Pointer_cast)
ot_check_test (Exception_std)
ot_check_test (Log_std)
ot_check_test (IdFactory_std IGNOREOUT)
ot_check_test (ComparisonOperator_std)
if (LIBXML2_FOUND)
ot_check_test (Study_saveload )
endif ()
ot_check_test (ResourceMap_std IGNOREOUT)
ot_check_test (Catalog_std IGNOREOUT)
ot_check_test (AtomicFunctions_std IGNOREOUT)

# Type
ot_check_test (Collection_std)
ot_check_test (Indices_std)
ot_check_test (Description_std)
ot_check_test (NumericalPoint_std)
ot_check_test (NumericalPoint_description)
ot_check_test (Matrix_std)
ot_check_test (IdentityMatrix_std)
ot_check_test (Tensor_std)
ot_check_test (ComplexTensor_std)
ot_check_test (SymmetricTensor_std)
ot_check_test (SquareMatrix_std)
ot_check_test (TriangularMatrix_std)
ot_check_test (SymmetricMatrix_std)
ot_check_test (Matrix_solve)
ot_check_test (Matrix_decomposition)
ot_check_test (SquareMatrix_lapack)
ot_check_test (SymmetricMatrix_lapack)
ot_check_test (Cache_std)
ot_check_test (ComplexMatrix_std)
ot_check_test (SquareComplexMatrix_std)
ot_check_test (HermitianMatrix_std)
ot_check_test (TriangularComplexMatrix_std)

# Func
ot_check_test (LinearNumericalMathEvaluationImplementation_std)
ot_check_test (ConstantNumericalMathGradientImplementation_std)
ot_check_test (AggregatedNumericalMathEvaluationImplementation_std)
ot_check_test (PiecewiseLinearEvaluationImplementation_std)
ot_check_test (PiecewiseHermiteEvaluationImplementation_std)
ot_check_test (P1LagrangeEvaluationImplementation_std)
if (OPENTURNS_HAVE_MUPARSER)
ot_check_test (AnalyticalNumericalMathEvaluationImplementation_std)
ot_check_test (AnalyticalNumericalMathGradientImplementation_std)
ot_check_test (AnalyticalNumericalMathHessianImplementation_std)
endif ()
ot_check_test (LinearNumericalMathFunction_std)
ot_check_test (LinearCombinationEvaluationImplementation_std)
ot_check_test (LinearCombinationGradientImplementation_std)
ot_check_test (LinearCombinationHessianImplementation_std)
ot_check_test (QuadraticNumericalMathEvaluationImplementation_std)
ot_check_test (LinearNumericalMathGradientImplementation_std)
ot_check_test (ConstantNumericalMathHessianImplementation_std)
ot_check_test (MethodBoundNumericalMathEvaluationImplementation_std)
ot_check_test (NumericalMathFunction_analytical)
ot_check_test (NumericalMathFunction_indicator)
ot_check_test (NumericalMathFunction_aggregated)
ot_check_test (NumericalMathFunction_dual_linear_combination)
ot_check_test (NumericalMathFunction_linear_combination)
ot_check_test (NumericalMathFunction_operations)
ot_check_test (NumericalMathFunction_parametric)
ot_check_test (NumericalMathFunction_data)
ot_check_test (NumericalMathFunction_history)

if (R_base_FOUND)
ot_check_test (NumericalMathFunction_draw)
endif ()
ot_check_test (UniVariatePolynomial_std)
ot_check_test (Basis_std)
ot_check_test (BasisSequence_std)
ot_check_test (LAR_std)
ot_check_test (DynamicalFunction_std)
ot_check_test (SpatialFunction_std)
ot_check_test (TemporalFunction_std)
ot_check_test (BoxCoxEvaluationImplementation_std)
ot_check_test (BoxCoxTransform_std)
ot_check_test (InverseBoxCoxEvaluationImplementation_std)
ot_check_test (InverseBoxCoxTransform_std)
ot_check_test (TrendEvaluationImplementation_std)
ot_check_test (TrendTransform_std)
ot_check_test (InverseTrendEvaluationImplementation_std)
ot_check_test (InverseTrendTransform_std)
ot_check_test (ExpertMixture_std)
ot_check_test (BasisFactory_std)

# Optim
ot_check_test (AbdoRackwitz_std)
ot_check_test (Cobyla_std)
ot_check_test (SQP_std)
ot_check_test (TNC_std)
ot_check_test (NearestPointChecker_std)

# Solver
ot_check_test (Bisection_std)
ot_check_test (Brent_std)
ot_check_test (Secant_std)
ot_check_test (RungeKutta_std)

# Stat
ot_check_test (NumericalSample_std)
ot_check_test (NumericalSample_split)
ot_check_test (NumericalSample_large)
ot_check_test (NumericalSample_computation)
ot_check_test (NumericalSample_operators)
ot_check_test (HistoryStrategy_std)
ot_check_test (CovarianceMatrixLapack_std)
ot_check_test (CorrelationMatrix_std)
ot_check_test (TestResult_std)
if (R_rot_FOUND)
ot_check_test (LinearModelFactory_std)
ot_check_test (LinearModel_std)
endif ()
ot_check_test (SensitivityAnalysis_std)
ot_check_test (ProcessSample_std)
ot_check_test (RandomGenerator_std)
ot_check_test (SobolSequence_std)
ot_check_test (FaureSequence_std)
ot_check_test (HaltonSequence_std)
ot_check_test (HaselgroveSequence_std)
ot_check_test (ReverseHaltonSequence_std)
ot_check_test (CorrelationAnalysis_std)
ot_check_test (TimeSeries_std)
ot_check_test (ExponentialCauchy_std)
ot_check_test (FilteringWindows_std)
ot_check_test (WelchFactory_std)
ot_check_test (ExponentialModel_std)
ot_check_test (DiracCovarianceModel_std)
ot_check_test (ExponentiallyDampedCosineModel_std)
ot_check_test (CauchyModel_std)
ot_check_test (SecondOrderModel_std)
ot_check_test (UserDefinedSpectralModel_std)
ot_check_test (UserDefinedCovarianceModel_std)
ot_check_test (UserDefinedStationaryCovarianceModel_std)

=== python/src/CMakeLists.txt ===
#                                               -*- cmake -*-

add_definitions (${OPENTURNS_SWIG_DEFINITIONS})

# generate SWIG runtime header
set (SWIG_PYTHON_OPTIONS "-python")
add_custom_command (OUTPUT  ${CMAKE_CURRENT_BINARY_DIR}/swig_runtime.hxx
                     COMMAND ${SWIG_EXECUTABLE}
                     ARGS ${SWIG_PYTHON_OPTIONS} ${CMAKE_SWIG_FLAGS} ${OPENTURNS_SWIG_DEFINITIONS} -external-runtime ${CMAKE_CURRENT_BINARY_DIR}/swig_runtime.hxx
                     COMMENT "Swig header")
add_custom_target (generate_swig_runtime DEPENDS ${CMAKE_CURRENT_BINARY_DIR}/swig_runtime.hxx)
add_custom_target (generate_docstrings)

include_directories (${CMAKE_CURRENT_BINARY_DIR})

include_directories (${INTERNAL_INCLUDE_DIRS})
include_directories (${CMAKE_CURRENT_SOURCE_DIR})

set (OPENTURNS_PYTHON_MODULES)
macro (ot_add_python_module MODULENAME SOURCEFILE)
  set_source_files_properties (${SOURCEFILE} PROPERTIES CPLUSPLUS ON)
  set_source_files_properties (${SOURCEFILE} PROPERTIES SWIG_MODULE_NAME ${MODULENAME})
  ot_install_swig_file (${SOURCEFILE})
  if (${ARGC} GREATER 2)
    set (SWIG_MODULE_${MODULENAME}_EXTRA_DEPS ${ARGN})
    list (APPEND SWIG_MODULE_${MODULENAME}_EXTRA_DEPS PythonWrappingFunctions.hxx)
  endif ()

  set (swig_other_sources)
  foreach (it ${ARGN})
    if (${it} MATCHES ".*\\.i$")
      ot_install_swig_file (${it})
    elseif(${it} MATCHES ".*_doc\\.i\\.in$")
     # handle docstring generation
      set (DOCSTRING_IN_FILE ${CMAKE_CURRENT_SOURCE_DIR}/${it})
      get_filename_component (DOCSTRING_FILE_BASENAME ${DOCSTRING_IN_FILE} NAME_WE)
      add_custom_target (generate_${DOCSTRING_FILE_BASENAME}
                          COMMAND ${CMAKE_COMMAND} -DDOCSTRING_IN_FILE=${DOCSTRING_IN_FILE} -DDOCSTRING_FILE=${CMAKE_CURRENT_BINARY_DIR}/${DOCSTRING_FILE_BASENAME}.i -P ${CMAKE_SOURCE_DIR}/cmake/escape_backslash_x4.cmake
                          DEPENDS ${DOCSTRING_IN_FILE})
      add_dependencies (generate_docstrings generate_${DOCSTRING_FILE_BASENAME})
      list (APPEND SWIGFILES ${CMAKE_CURRENT_BINARY_DIR}/${DOCSTRING_FILE_BASENAME}.i)
    else ()
      list (APPEND swig_other_sources "${it}")
    endif ()
  endforeach ()

  # workaround for a bug in UseSWIG script not supporting multiple modules and parallel compilation
  # http://www.cmake.org/pipermail/cmake/2011-January/042345.html
  if (CMAKE_VERSION VERSION_LESS 2.8.5)
    set(swig_extra_generated_files)
  endif ()

  swig_add_module (${MODULENAME} python ${SOURCEFILE} ${swig_other_sources})

  add_dependencies (${SWIG_MODULE_${MODULENAME}_REAL_NAME} generate_swig_runtime generate_docstrings)
  swig_link_libraries (${MODULENAME} OT)

  if (LINK_PYTHON_LIBRARY)
    swig_link_libraries (${MODULENAME} ${PYTHON_LIBRARIES})
  endif ()

  set_target_properties (${SWIG_MODULE_${MODULENAME}_REAL_NAME} PROPERTIES NO_SONAME ON)

  list (APPEND OPENTURNS_PYTHON_MODULES ${MODULENAME})
endmacro (ot_add_python_module)

install (FILES PythonNumericalMathEvaluationImplementation.hxx
                PythonNumericalMathGradientImplementation.hxx
                PythonNumericalMathHessianImplementation.hxx
                PythonDynamicalFunctionImplementation.hxx
                PythonRandomVectorImplementation.hxx
                PythonDistributionImplementation.hxx
                PythonWrappingFunctions.hxx
          DESTINATION ${OPENTURNS_INCLUDE_PATH}
       )

if (LIBXML2_FOUND)
  list (APPEND SWIG_MODULE_common_EXTRA_FLAGS -DOPENTURNS_HAVE_LIBXML2=1)
endif ()
if (MUPARSER_FOUND)
  list (APPEND SWIG_MODULE_func_EXTRA_FLAGS -DOPENTURNS_HAVE_MUPARSER=1)
endif ()

ot_add_python_module(common common_module.i
                      OTtypes.i
                      OTexceptions.i
                      Memory.i
                      Object.i Object_doc.i.in
                      PersistentObject.i PersistentObject_doc.i.in
                      Study.i Study_doc.i.in
                      StorageManager.i StorageManager_doc.i.in
                      XMLStorageManager.i XMLStorageManager_doc.i.in
                      Log.i Log_doc.i.in
                      TTY.i TTY_doc.i.in
                      Path.i Path_doc.i.in
                      Catalog.i
                      ResourceMap.i ResourceMap_doc.i.in
                      ComparisonOperatorImplementation.i
                      ComparisonOperator.i ComparisonOperator_doc.i.in
                      Equal.i Equal_doc.i.in
                      Greater.i Greater_doc.i.in
                      GreaterOrEqual.i GreaterOrEqual_doc.i.in
                      Less.i Less_doc.i.in
                      LessOrEqual.i LessOrEqual_doc.i.in
                      Cache.i
                      PlatformInfo.i PlatformInfo_doc.i.in
                      SharedPointer.i
                      Pointer.i
                      InterfaceObject.i InterfaceObject_doc.i.in
                      TypedInterfaceObject.i
                      TypedCollectionInterfaceObject.i
                      BaseCommonTemplateDefs.i
                   )

ot_add_python_module(typ typ_module.i
                      Collection.i Collection_doc.i.in
                      PersistentCollection.i
                      Description.i Description_doc.i.in
                      NumericalPoint.i NumericalPoint_doc.i.in
                      NumericalPointWithDescription.i NumericalPointWithDescription_doc.i.in
                      DomainImplementation.i DomainImplementation_doc.i.in
                      Interval.i Interval_doc.i.in
                      Indices.i Indices_doc.i.in
                      MatrixImplementation.i
                      Matrix.i Matrix_doc.i.in
                      SquareMatrix.i SquareMatrix_doc.i.in
                      SymmetricMatrix.i SymmetricMatrix_doc.i.in
                      TensorImplementation.i TensorImplementation_doc.i.in
                      Tensor.i Tensor_doc.i.in
                      SymmetricTensor.i SymmetricTensor_doc.i.in
                      ComplexTensorImplementation.i
                      ComplexTensor.i ComplexTensor_doc.i.in
                      ComplexMatrixImplementation.i ComplexMatrixImplementation_doc.i.in
                      ComplexMatrix.i ComplexMatrix_doc.i.in
                      HermitianMatrix.i HermitianMatrix_doc.i.in
                      SquareComplexMatrix.i SquareComplexMatrix_doc.i.in
                      TriangularMatrix.i TriangularMatrix_doc.i.in
                      TriangularComplexMatrix.i TriangularComplexMatrix_doc.i.in
                      CovarianceMatrix.i CovarianceMatrix_doc.i.in
                      CorrelationMatrix.i CorrelationMatrix_doc.i.in
                      IdentityMatrix.i
                      NumericalSample.i NumericalSample_doc.i.in
                      FieldImplementation.i FieldImplementation_doc.i.in
                      Field.i Field_doc.i.in
                      ProcessSample.i ProcessSample_doc.i.in
                      TimeSeries.i TimeSeries_doc.i.in
                      HistoryStrategyImplementation.i HistoryStrategyImplementation_doc.i.in
                      HistoryStrategy.i HistoryStrategy_doc.i.in
                      BaseTypTemplateDefs.i
                   )

ot_add_python_module(statistics statistics_module.i
                      LevelSet.i LevelSet_doc.i.in
                      Compact.i Compact_doc.i.in
                      Full.i Full_doc.i.in
                      Last.i Last_doc.i.in
                      Null.i Null_doc.i.in
		      HMatrixParameters.i HMatrixParameters_doc.i.in
                      LinearModel.i LinearModel_doc.i.in
                      LinearModelFactory.i LinearModelFactory_doc.i.in
                      TestResult.i TestResult_doc.i.in
                      RandomGenerator.i RandomGenerator_doc.i.in
                      RandomGeneratorState.i
                      CorrelationAnalysis.i CorrelationAnalysis_doc.i.in
                      SensitivityAnalysis.i SensitivityAnalysis_doc.i.in
                      LowDiscrepancySequenceImplementation.i LowDiscrepancySequenceImplementation_doc.i.in
                      LowDiscrepancySequence.i LowDiscrepancySequence_doc.i.in
                      SobolSequence.i SobolSequence_doc.i.in
                      FaureSequence.i FaureSequence_doc.i.in
                      HaltonSequence.i HaltonSequence_doc.i.in
                      HaselgroveSequence.i HaselgroveSequence_doc.i.in
                      ReverseHaltonSequence.i ReverseHaltonSequence_doc.i.in
                      SecondOrderModelImplementation.i SecondOrderModelImplementation_doc.i.in
                      SecondOrderModel.i SecondOrderModel_doc.i.in
                      ExponentialCauchy.i ExponentialCauchy_doc.i.in
                      SphericalModel.i SphericalModel_doc.i.in
                      FilteringWindowsImplementation.i FilteringWindowsImplementation_doc.i.in
                      FilteringWindows.i FilteringWindows_doc.i.in
                      Hamming.i Hamming_doc.i.in
                      Hanning.i Hanning_doc.i.in
                      FFTImplementation.i FFTImplementation_doc.i.in
                      FFT.i FFT_doc.i.in
                      SpectralModelImplementation.i SpectralModelImplementation_doc.i.in
                      SpectralModel.i SpectralModel_doc.i.in
                      CovarianceModelImplementation.i CovarianceModelImplementation_doc.i.in
                      CovarianceModel.i CovarianceModel_doc.i.in
                      StationaryCovarianceModel.i 
                      SpectralModelFactoryImplementation.i SpectralModelFactoryImplementation_doc.i.in
                      SpectralModelFactory.i SpectralModelFactory_doc.i.in
                      UserDefinedSpectralModel.i UserDefinedSpectralModel_doc.i.in
                      WelchFactory.i WelchFactory_doc.i.in
                      ExponentialModel.i ExponentialModel_doc.i.in
                      ExponentiallyDampedCosineModel.i ExponentiallyDampedCosineModel_doc.i.in
                      CauchyModel.i CauchyModel_doc.i.in
                      CovarianceModelFactoryImplementation.i CovarianceModelFactoryImplementation_doc.i.in
                      CovarianceModelFactory.i CovarianceModelFactory_doc.i.in
                      UserDefinedCovarianceModel.i UserDefinedCovarianceModel_doc.i.in
                      UserDefinedStationaryCovarianceModel.i UserDefinedStationaryCovarianceModel_doc.i.in
                      StationaryCovarianceModelFactory.i StationaryCovarianceModelFactory_doc.i.in
                      NonStationaryCovarianceModelFactory.i NonStationaryCovarianceModelFactory_doc.i.in
                      SquaredExponential.i SquaredExponential_doc.i.in
                      GeneralizedExponential.i GeneralizedExponential_doc.i.in
                      AbsoluteExponential.i AbsoluteExponential_doc.i.in
                      MaternModel.i MaternModel_doc.i.in
		      DiracCovarianceModel.i DiracCovarianceModel_doc.i.in
                      ProductCovarianceModel.i ProductCovarianceModel_doc.i.in
		      TensorizedCovarianceModel.i TensorizedCovarianceModel_doc.i.in
                      HMatrixFactory.i
                      HMatrix.i
                      HMatrixImplementation.i
                      BaseStatisticsTemplateDefs.i
                   )

ot_add_python_module(geom geom_module.i
                      Domain.i Domain_doc.i.in
                      BipartiteGraph.i BipartiteGraph_doc.i.in
                      Mesh.i Mesh_doc.i.in
                      RegularGrid.i RegularGrid_doc.i.in
                      MeshFactoryImplementation.i MeshFactoryImplementation_doc.i.in
                      MeshFactory.i MeshFactory_doc.i.in
                      IntervalMesher.i IntervalMesher_doc.i.in
                      BaseGeomTemplateDefs.i
                    )

ot_add_python_module(graph graph_module.i
                      DrawableImplementation.i DrawableImplementation_doc.i.in

=== python/test/CMakeLists.txt ===
#                                               -*- cmake -*-

set (NEW_PATH "$ENV{PATH}:${INSTALL_DESTDIR}${EXAMPLE_PATH}")

set (ADAPT_CHECK_TESTS_EXPONENT)
set (REPLACE_EOL " | cat ")
if (MINGW)
  # replace dos eols
  set (REPLACE_EOL " | tr -d '\\\\015' ")
  # By default, Mingw-g++ puts 3 digits to real exponent whereas g++ puts 2.
  set (ADAPT_CHECK_TESTS_EXPONENT "PRINTF_EXPONENT_DIGITS=2")
endif ()


set (PYINSTALLCHECK_ENVIRONMENT "AUTOTEST_PATH=${INSTALL_DESTDIR}${EXAMPLE_PATH}"
                                 "OPENTURNS_CONFIG_PATH=${INSTALL_DESTDIR}${SYSCONFIG_PATH}/openturns"
                                 "PATH=${NEW_PATH}"
                                 "LD_LIBRARY_PATH=${INSTALL_DESTDIR}${LIBRARY_PATH}:$ENV{LD_LIBRARY_PATH}"
                                 "PYTHONPATH=${INSTALL_DESTDIR}${PYTHON_MODULE_PATH}${PATH_SEP}$ENV{PYTHONPATH}"
                                 ${ADAPT_CHECK_TESTS_EXPONENT}
   )

if (MINGW)
  macro (create_check_file FILE_NAME)
    file (WRITE ${FILE_NAME} "#!/bin/sh\n\n")
    file (APPEND ${FILE_NAME} "#set -e\n\n")
    #file (APPEND ${FILE_NAME} "#${CHECK_ENVIRONMENT}\n\n")
    file (APPEND ${FILE_NAME} "export PRINTF_EXPONENT_DIGITS=2\n")
    file (APPEND ${FILE_NAME} "export AUTOTEST_PATH=$PWD\n")
    file (APPEND ${FILE_NAME} "export OPENTURNS_CONFIG_PATH=$PWD/..\n")
    file (APPEND ${FILE_NAME} "#export OPENTURNS_LOG_SEVERITY=ALL\n")
    file (APPEND ${FILE_NAME} "DEBUG_FILE=stdouterr.dbg \n")
    file (APPEND ${FILE_NAME} "export OPENTURNS_HOME=$PWD/..\n")
    file (APPEND ${FILE_NAME} "PATH=$PWD:$PWD/..:$PATH\n")
    file (APPEND ${FILE_NAME} "PYTHON_EXE=../../../../python.exe\n\n")
    file (APPEND ${FILE_NAME} "FAILED_TEST=\"\"\n")
    file (APPEND ${FILE_NAME} "function check_error {\nif [ \"$?\" != \"0\" ]; then\n  FAILED_TEST=\"$FAILED_TEST $1\"\n  echo \"std_err output:\"\n  cat $DEBUG_FILE\n  echo \"Test #$1: $2 failed!\"\n  echo\nfi\n}\n\n")
  endmacro (create_check_file FILE_NAME)

  macro (add_check_file FILE_NAME TESTNAME EXTERNAL_COMMAND CUR_CHECK)
    file (APPEND ${FILE_NAME} "echo \"Test #${CUR_CHECK}/$NB_CHECK: ${TESTNAME}\"\n")
    file (APPEND ${FILE_NAME} "${EXTERNAL_COMMAND}\n")
    file (APPEND ${FILE_NAME} "check_error ${CUR_CHECK} ${TESTNAME}\n\n")
  endmacro (add_check_file FILE_NAME TESTNAME EXTERNAL_COMMAND CUR_CHECK)

  macro (finish_check_file FILE_NAME NB_CHECK)
    file (APPEND ${FILE_NAME} "}\n\n")
    file (APPEND ${FILE_NAME} "NB_CHECK=${NB_CHECK}\n")
    file (APPEND ${FILE_NAME} "start_tests\necho\n")
    file (APPEND ${FILE_NAME} "RC=0\nif [ \"$FAILED_TEST\" = \"\" ]; then\n  echo \"Every check tests are OK.\"\n")
    file (APPEND ${FILE_NAME} "else\n  echo \"Tests$FAILED_TEST failed!\"\n  RC=1\nfi\n")
    file (APPEND ${FILE_NAME} "exit $RC\n")
  endmacro (finish_check_file FILE_NAME)


  set (EXTERNAL_PYTHONINSTALLCHECK_FILE "${CMAKE_CURRENT_BINARY_DIR}/start_pythoninstallcheck_test.sh")
  create_check_file (${EXTERNAL_PYTHONINSTALLCHECK_FILE})
  #file (APPEND ${EXTERNAL_PYTHONINSTALLCHECK_FILE} "#${INSTALLCHECK_ENVIRONMENT}\n\n")
  #file (APPEND ${EXTERNAL_PYTHONINSTALLCHECK_FILE} "export abs_srcdir=$PWD\n")
  file (APPEND ${EXTERNAL_PYTHONINSTALLCHECK_FILE} "start_tests() {\n")
  set (CUR_PYTHONINSTALLCHECK 0)

endif ()

# This macro compiles on the fly and run the corresponding post-installation test
# It can have two optional arguments PRE and POST followed by some shell command to be run
# before or after the test if needed
# PRE and POST options cn be repeated many times: the arguments will be run one after the other
# in the order of appearence. If one fails, the whole command fails.
set (PYINSTALLCHECK_TO_BE_RUN)
macro (ot_pyinstallcheck_test TESTNAME)
  set (TESTNAME_TGT t_${TESTNAME})
  set (TESTNAME_SRC ${TESTNAME_TGT}.py)
  set (TESTNAME_LOC ${CMAKE_CURRENT_SOURCE_DIR}/${TESTNAME_SRC})
  set (_CMD)
  set (_PRE)
  set (_POST)
  set (_PARAMS)
  set (_IGNOREOUT OFF)
  foreach (_ARG ${ARGN})
    string (TOUPPER ${_ARG} ARG)
    if (${ARG} MATCHES PRE)
      set (_CMD PRE)
    elseif (${ARG} MATCHES POST)
      set (_CMD POST)
    elseif (${ARG} MATCHES PARAMS)
      set (_CMD PARAMS)
    elseif (${ARG} MATCHES IGNOREOUT)
      set (_IGNOREOUT ON)
    else (${ARG} MATCHES PRE)
      if (${_CMD} MATCHES PRE)
        set (_PRE "${_PRE} ${_ARG} && ")
      elseif (${_CMD} MATCHES POST)
        set (_POST "${_POST} && ${_ARG}")
      elseif (${_CMD} MATCHES PARAMS)
        set (_PARAMS "${_PARAMS} ${_ARG}")
      endif  (${_CMD} MATCHES PRE)
      set (_CMD)
    endif (${ARG} MATCHES PRE)
  endforeach (_ARG)
  
  if (_IGNOREOUT)
    set (COMMAND "(${PYTHON_EXECUTABLE} ${TESTNAME_LOC} ${_PARAMS} > /dev/null)")
    set (EXTERNAL_COMMAND "$PYTHON_EXE ${TESTNAME_SRC} > $DEBUG_FILE 2>&1")
  else (_IGNOREOUT)
    set (TESTNAME_OUT ${TESTNAME_TGT}.expout)
    get_source_file_property (OUTFILE_LOC ${TESTNAME_OUT} LOCATION)
    set (OUTFILE_LOC ${CMAKE_CURRENT_SOURCE_DIR}/${TESTNAME_OUT})
    set (COMMAND "(${PYTHON_EXECUTABLE} ${TESTNAME_LOC} ${_PARAMS} ${REPLACE_EOL} > ${CMAKE_CURRENT_BINARY_DIR}/${TESTNAME_TGT}.out) && diff -u ${OUTFILE_LOC} ${CMAKE_CURRENT_BINARY_DIR}/${TESTNAME_TGT}.out")
    set (EXTERNAL_COMMAND "($PYTHON_EXE ${TESTNAME_SRC} 2>$DEBUG_FILE | tr -d '\\\\r' > ${TESTNAME_TGT}.out) && diff -u ${TESTNAME_SRC}.expout ${TESTNAME_TGT}.out")
  endif (_IGNOREOUT)

  if (_PRE OR _POST)
    set (COMMAND "${_PRE}${COMMAND}${_POST}")
    #not useful
    #set (EXTERNAL_COMMAND "${_PRE}${EXTERNAL_COMMAND}${_POST}")
  endif (_PRE OR _POST)

  add_test (pyinstallcheck_${TESTNAME} "sh" "-c" "${COMMAND}")

  if (INSTALL_TESTS)
    install (FILES ${TESTNAME_OUT}
              DESTINATION ${EXAMPLE_PATH} 
              RENAME ${TESTNAME_SRC}.expout
           )
          add_check_file (${EXTERNAL_PYTHONINSTALLCHECK_FILE} ${TESTNAME_SRC} ${EXTERNAL_COMMAND} ${CUR_PYTHONINSTALLCHECK})
    math(EXPR CUR_PYTHONINSTALLCHECK "${CUR_PYTHONINSTALLCHECK} + 1")
  endif ()


  set_tests_properties (pyinstallcheck_${TESTNAME} PROPERTIES ENVIRONMENT "${PYINSTALLCHECK_ENVIRONMENT}")
  list (APPEND PYINSTALLCHECK_TO_BE_RUN ${TESTNAME_SRC})
  install (FILES ${TESTNAME_SRC}
            DESTINATION ${EXAMPLE_PATH} 
            PERMISSIONS OWNER_READ OWNER_WRITE GROUP_READ WORLD_READ OWNER_EXECUTE GROUP_EXECUTE WORLD_EXECUTE
         )
endmacro (ot_pyinstallcheck_test)


## Python post-installation tests

# Common
if (LIBXML2_FOUND)
  ot_pyinstallcheck_test (Object_pickle)
endif ()
ot_pyinstallcheck_test (ComparisonOperator_std)
if (LIBXML2_FOUND)
ot_pyinstallcheck_test (Study_saveload)
endif ()
ot_pyinstallcheck_test (Path_std IGNOREOUT)
ot_pyinstallcheck_test (ResourceMap_std IGNOREOUT)
ot_pyinstallcheck_test (Catalog_std IGNOREOUT)

# Type
ot_pyinstallcheck_test (Collection_std)
ot_pyinstallcheck_test (Description_std)
ot_pyinstallcheck_test (Indices_std)
ot_pyinstallcheck_test (NumericalPoint_std)
ot_pyinstallcheck_test (NumericalPoint_description)
ot_pyinstallcheck_test (Matrix_std)
ot_pyinstallcheck_test (SymmetricMatrix_lapack)
ot_pyinstallcheck_test (SquareMatrix_lapack)
ot_pyinstallcheck_test (SquareMatrix_std)
ot_pyinstallcheck_test (TriangularMatrix_std)
ot_pyinstallcheck_test (SymmetricMatrix_std)
ot_pyinstallcheck_test (Tensor_std)
ot_pyinstallcheck_test (ComplexTensor_std)
ot_pyinstallcheck_test (SymmetricTensor_std)
ot_pyinstallcheck_test (Matrix_solve)
ot_pyinstallcheck_test (Matrix_decomposition)
ot_pyinstallcheck_test (IdentityMatrix_std)
ot_pyinstallcheck_test (RegularGrid_std)
ot_pyinstallcheck_test (ComplexMatrix_std)
ot_pyinstallcheck_test (SquareComplexMatrix_std)
ot_pyinstallcheck_test (HermitianMatrix_std)
ot_pyinstallcheck_test (TriangularComplexMatrix_std)
ot_pyinstallcheck_test (Matrix_slice)
ot_pyinstallcheck_test (Matrix_operators)
if (NUMPY_FOUND)
  ot_pyinstallcheck_test (Matrix_numpy)
endif ()

# Func
ot_pyinstallcheck_test (NumericalMathFunction_std)
ot_pyinstallcheck_test (NumericalMathFunction_composition)
ot_pyinstallcheck_test (NumericalMathFunction_python)
if (LIBXML2_FOUND)
ot_pyinstallcheck_test (NumericalMathFunction_python_saveload)
endif ()
ot_pyinstallcheck_test (NumericalMathFunction_data)
ot_pyinstallcheck_test (NumericalMathFunction_operations)
ot_pyinstallcheck_test (NumericalMathFunction_parametric)

if (R_base_FOUND)
ot_pyinstallcheck_test (NumericalMathFunction_draw)
endif ()
ot_pyinstallcheck_test (NumericalMathFunction_history)
ot_pyinstallcheck_test (AggregatedNumericalMathEvaluationImplementation_std)
ot_pyinstallcheck_test (AnalyticalNumericalMathEvaluationImplementation_std)
ot_pyinstallcheck_test (AnalyticalNumericalMathGradientImplementation_std)
ot_pyinstallcheck_test (AnalyticalNumericalMathHessianImplementation_std)
ot_pyinstallcheck_test (LinearNumericalMathFunction_std)
ot_pyinstallcheck_test (LinearNumericalMathEvaluationImplementation_std)
ot_pyinstallcheck_test (LinearCombinationEvaluationImplementation_std)
ot_pyinstallcheck_test (LinearCombinationGradientImplementation_std)
ot_pyinstallcheck_test (LinearCombinationHessianImplementation_std)
ot_pyinstallcheck_test (PiecewiseLinearEvaluationImplementation_std)
ot_pyinstallcheck_test (PiecewiseHermiteEvaluationImplementation_std)
ot_pyinstallcheck_test (QuadraticNumericalMathEvaluationImplementation_std)
ot_pyinstallcheck_test (LinearNumericalMathGradientImplementation_std)
ot_pyinstallcheck_test (NumericalMathFunction_aggregated)
ot_pyinstallcheck_test (NumericalMathFunction_analytical)
ot_pyinstallcheck_test (NumericalMathFunction_dual_linear_combination)
ot_pyinstallcheck_test (NumericalMathFunction_indicator)
ot_pyinstallcheck_test (NumericalMathFunction_linear_combination)
ot_pyinstallcheck_test (ConstantNumericalMathGradientImplementation_std)
ot_pyinstallcheck_test (ConstantNumericalMathHessianImplementation_std)
ot_pyinstallcheck_test (ConstantNumericalMathHessianImplementation_std)
ot_pyinstallcheck_test (ConstantNumericalMathHessianImplementation_std)
ot_pyinstallcheck_test (Basis_std)
ot_pyinstallcheck_test (BasisSequence_std)
ot_pyinstallcheck_test (LAR_std)
ot_pyinstallcheck_test (DynamicalFunction_std)
ot_pyinstallcheck_test (SpatialFunction_std)
ot_pyinstallcheck_test (TemporalFunction_std)
ot_pyinstallcheck_test (BoxCoxEvaluationImplementation_std)
ot_pyinstallcheck_test (BoxCoxTransform_std)
ot_pyinstallcheck_test (InverseBoxCoxEvaluationImplementation_std)
ot_pyinstallcheck_test (InverseBoxCoxTransform_std)
ot_pyinstallcheck_test (TrendEvaluationImplementation_std)
ot_pyinstallcheck_test (TrendTransform_std)
ot_pyinstallcheck_test (InverseTrendEvaluationImplementation_std)
ot_pyinstallcheck_test (InverseTrendTransform_std)
ot_pyinstallcheck_test (ExpertMixture_std)
ot_pyinstallcheck_test (UniVariatePolynomial_std)
ot_pyinstallcheck_test (BasisFactory_std)
ot_pyinstallcheck_test (Field_std)

# Stat
ot_pyinstallcheck_test (NumericalSample_std)
ot_pyinstallcheck_test (NumericalSample_computation)
ot_pyinstallcheck_test (NumericalSample_slice)
ot_pyinstallcheck_test (NumericalSample_split)
ot_pyinstallcheck_test (NumericalSample_large)
ot_pyinstallcheck_test (NumericalSample_bug14)
ot_pyinstallcheck_test (NumericalSample_csv)
ot_pyinstallcheck_test (NumericalSample_operators)
ot_pyinstallcheck_test (HistoryStrategy_std)
ot_pyinstallcheck_test (CovarianceMatrixLapack_std)
ot_pyinstallcheck_test (CorrelationMatrix_std)
if (R_rot_FOUND)
ot_pyinstallcheck_test (LinearModel_std)
ot_pyinstallcheck_test (LinearModelFactory_std)
endif ()
ot_pyinstallcheck_test (ProcessSample_std)
ot_pyinstallcheck_test (RandomGenerator_std)
ot_pyinstallcheck_test (SobolSequence_std)
ot_pyinstallcheck_test (FaureSequence_std)
ot_pyinstallcheck_test (HaltonSequence_std)
ot_pyinstallcheck_test (HaselgroveSequence_std)
ot_pyinstallcheck_test (ReverseHaltonSequence_std)
ot_pyinstallcheck_test (TestResult_std)
ot_pyinstallcheck_test (SensitivityAnalysis_std)
ot_pyinstallcheck_test (CorrelationAnalysis_std)
ot_pyinstallcheck_test (TimeSeries_std)
ot_pyinstallcheck_test (ExponentialCauchy_std)

=== lib/src/Base/Algo/CMakeLists.txt ===
#                                               -*- cmake -*-

# Register current directory files
ot_add_current_dir_to_include_dirs ()

ot_add_source_file (ApproximationAlgorithmImplementation.cxx)
ot_add_source_file (ApproximationAlgorithm.cxx)
ot_add_source_file (ApproximationAlgorithmImplementationFactory.cxx)
ot_add_source_file (ClassifierImplementation.cxx)
ot_add_source_file (Classifier.cxx)
ot_add_source_file (FittingAlgorithmImplementation.cxx)
ot_add_source_file (FittingAlgorithm.cxx)
ot_add_source_file (CorrectedLeaveOneOut.cxx)
ot_add_source_file (KDTree.cxx)
ot_add_source_file (KFold.cxx)
ot_add_source_file (LeastSquaresMetaModelSelection.cxx)
ot_add_source_file (LeastSquaresMetaModelSelectionFactory.cxx)
ot_add_source_file (PenalizedLeastSquaresAlgorithm.cxx)
ot_add_source_file (PenalizedLeastSquaresAlgorithmFactory.cxx)
ot_add_source_file (FFTImplementation.cxx)
ot_add_source_file (FFT.cxx)
ot_add_source_file (KissFFT.cxx)
ot_add_source_file (IntegrationAlgorithmImplementation.cxx)
ot_add_source_file (IntegrationAlgorithm.cxx)
ot_add_source_file (GaussKronrod.cxx)
ot_add_source_file (GaussKronrodRule.cxx)
ot_add_source_file (IteratedQuadrature.cxx)
ot_add_source_file (DesignProxy.cxx)
ot_add_source_file (LeastSquaresMethodImplementation.cxx)
ot_add_source_file (LeastSquaresMethod.cxx)
ot_add_source_file (QRMethod.cxx)
ot_add_source_file (SVDMethod.cxx)
ot_add_source_file (CholeskyMethod.cxx)
ot_add_source_file (KarhunenLoeveP1Factory.cxx)

ot_install_header_file (OTAlgo.hxx)
ot_install_header_file (ApproximationAlgorithmImplementation.hxx)
ot_install_header_file (ApproximationAlgorithm.hxx)
ot_install_header_file (ApproximationAlgorithmImplementationFactory.hxx)
ot_install_header_file (ClassifierImplementation.hxx)
ot_install_header_file (Classifier.hxx)
ot_install_header_file (FittingAlgorithmImplementation.hxx)
ot_install_header_file (FittingAlgorithm.hxx)
ot_install_header_file (CorrectedLeaveOneOut.hxx)
ot_install_header_file (KDTree.hxx)
ot_install_header_file (KFold.hxx)
ot_install_header_file (LeastSquaresMetaModelSelection.hxx)
ot_install_header_file (LeastSquaresMetaModelSelectionFactory.hxx)
ot_install_header_file (PenalizedLeastSquaresAlgorithm.hxx)
ot_install_header_file (PenalizedLeastSquaresAlgorithmFactory.hxx)
ot_install_header_file (FFTImplementation.hxx)
ot_install_header_file (FFT.hxx)
ot_install_header_file (KissFFT.hxx)
# ot_install_header_file (kissfft.hh)
ot_install_header_file (IntegrationAlgorithmImplementation.hxx)
ot_install_header_file (IntegrationAlgorithm.hxx)
ot_install_header_file (GaussKronrod.hxx)
ot_install_header_file (GaussKronrodRule.hxx)
ot_install_header_file (IteratedQuadrature.hxx)
ot_install_header_file (DesignProxy.hxx)
ot_install_header_file (LeastSquaresMethodImplementation.hxx)
ot_install_header_file (LeastSquaresMethod.hxx)
ot_install_header_file (QRMethod.hxx)
ot_install_header_file (SVDMethod.hxx)
ot_install_header_file (CholeskyMethod.hxx)
ot_install_header_file (KarhunenLoeveP1Factory.hxx)

=== lib/src/Base/Func/CMakeLists.txt ===
#                                               -*- cmake -*-

# Register current directory files
ot_add_current_dir_to_include_dirs ()

if (MUPARSER_FOUND)
ot_add_source_file (AnalyticalParser.cxx)
ot_add_source_file (AnalyticalNumericalMathEvaluationImplementation.cxx)
ot_add_source_file (AnalyticalNumericalMathGradientImplementation.cxx)
ot_add_source_file (AnalyticalNumericalMathHessianImplementation.cxx)
endif ()
ot_add_source_file (EnumerateFunction.cxx)
ot_add_source_file (EnumerateFunctionImplementation.cxx)
ot_add_source_file (LinearEnumerateFunction.cxx)
ot_add_source_file (HyperbolicAnisotropicEnumerateFunction.cxx)
ot_add_source_file (DynamicalFunction.cxx)
ot_add_source_file (DynamicalFunctionImplementation.cxx)
ot_add_source_file (SpatialFunction.cxx)
ot_add_source_file (TemporalFunction.cxx)
ot_add_source_file (NumericalMathFunction.cxx)
ot_add_source_file (NumericalMathFunctionImplementation.cxx)
ot_add_source_file (ComposedNumericalMathFunction.cxx)
ot_add_source_file (LinearNumericalMathFunction.cxx)
ot_add_source_file (QuadraticNumericalMathFunction.cxx)
ot_add_source_file (NumericalMathEvaluationImplementation.cxx)
ot_add_source_file (NumericalMathGradientImplementation.cxx)
ot_add_source_file (NumericalMathHessianImplementation.cxx)
ot_add_source_file (NoNumericalMathEvaluationImplementation.cxx)
ot_add_source_file (NoNumericalMathGradientImplementation.cxx)
ot_add_source_file (NoNumericalMathHessianImplementation.cxx)
ot_add_source_file (LinearNumericalMathEvaluationImplementation.cxx)
ot_add_source_file (QuadraticNumericalMathEvaluationImplementation.cxx)
ot_add_source_file (LinearNumericalMathGradientImplementation.cxx)
ot_add_source_file (ConstantNumericalMathGradientImplementation.cxx)
ot_add_source_file (ConstantNumericalMathHessianImplementation.cxx)
ot_add_source_file (ComposedNumericalMathEvaluationImplementation.cxx)
ot_add_source_file (ComposedNumericalMathGradientImplementation.cxx)
ot_add_source_file (ComposedNumericalMathHessianImplementation.cxx)
ot_add_source_file (IndicatorNumericalMathEvaluationImplementation.cxx)
ot_add_source_file (UniVariatePolynomialImplementation.cxx)
ot_add_source_file (UniVariatePolynomial.cxx)
ot_add_source_file (ProductPolynomialEvaluationImplementation.cxx)
ot_add_source_file (DualLinearCombinationEvaluationImplementation.cxx)
ot_add_source_file (DualLinearCombinationGradientImplementation.cxx)
ot_add_source_file (DualLinearCombinationHessianImplementation.cxx)
ot_add_source_file (ExpertMixture.cxx)
ot_add_source_file (LinearCombinationEvaluationImplementation.cxx)
ot_add_source_file (LinearCombinationGradientImplementation.cxx)
ot_add_source_file (LinearCombinationHessianImplementation.cxx)
ot_add_source_file (ProductNumericalMathEvaluationImplementation.cxx)
ot_add_source_file (ProductNumericalMathFunction.cxx)
ot_add_source_file (ProductNumericalMathGradientImplementation.cxx)
ot_add_source_file (ProductNumericalMathHessianImplementation.cxx)
ot_add_source_file (DatabaseNumericalMathEvaluationImplementation.cxx)
ot_add_source_file (AggregatedNumericalMathGradientImplementation.cxx)
ot_add_source_file (AggregatedNumericalMathHessianImplementation.cxx)
ot_add_source_file (AggregatedNumericalMathEvaluationImplementation.cxx)
ot_add_source_file (PiecewiseLinearEvaluationImplementation.cxx)
ot_add_source_file (PiecewiseHermiteEvaluationImplementation.cxx)
ot_add_source_file (ProductPolynomialHessianImplementation.cxx)
ot_add_source_file (ProductPolynomialGradientImplementation.cxx)
ot_add_source_file (BasisImplementation.cxx)
ot_add_source_file (Basis.cxx)
ot_add_source_file (FiniteBasis.cxx)
ot_add_source_file (BasisSequenceImplementation.cxx)
ot_add_source_file (BasisSequence.cxx)
ot_add_source_file (BasisSequenceFactoryImplementation.cxx)
ot_add_source_file (BasisSequenceFactory.cxx)
ot_add_source_file (LAR.cxx)
ot_add_source_file (BoxCoxEvaluationImplementation.cxx)
ot_add_source_file (BoxCoxGradientImplementation.cxx)
ot_add_source_file (BoxCoxHessianImplementation.cxx)
ot_add_source_file (BoxCoxTransform.cxx)
ot_add_source_file (InverseBoxCoxEvaluationImplementation.cxx)
ot_add_source_file (InverseBoxCoxGradientImplementation.cxx)
ot_add_source_file (InverseBoxCoxHessianImplementation.cxx)
ot_add_source_file (InverseBoxCoxTransform.cxx)
ot_add_source_file (TrendEvaluationImplementation.cxx)
ot_add_source_file (TrendTransform.cxx)
ot_add_source_file (InverseTrendEvaluationImplementation.cxx)
ot_add_source_file (InverseTrendTransform.cxx)
ot_add_source_file (BasisFactory.cxx)
ot_add_source_file (ConstantBasisFactory.cxx)
ot_add_source_file (LinearBasisFactory.cxx)
ot_add_source_file (QuadraticBasisFactory.cxx)
ot_add_source_file (ParametricEvaluationImplementation.cxx)
ot_add_source_file (ParametricGradientImplementation.cxx)
ot_add_source_file (ParametricHessianImplementation.cxx)
ot_add_source_file (P1LagrangeEvaluationImplementation.cxx)
ot_add_source_file (FunctionalBasisImplementation.cxx)
ot_add_source_file (FunctionalBasis.cxx)

if (MUPARSER_FOUND)
ot_install_header_file (AnalyticalParser.hxx)
ot_install_header_file (AnalyticalNumericalMathEvaluationImplementation.hxx)
ot_install_header_file (AnalyticalNumericalMathGradientImplementation.hxx)
ot_install_header_file (AnalyticalNumericalMathHessianImplementation.hxx)
endif ()
ot_install_header_file (EnumerateFunction.hxx)
ot_install_header_file (EnumerateFunctionImplementation.hxx)
ot_install_header_file (LinearEnumerateFunction.hxx)
ot_install_header_file (HyperbolicAnisotropicEnumerateFunction.hxx)
ot_install_header_file (ProductPolynomialGradientImplementation.hxx)
ot_install_header_file (ProductPolynomialHessianImplementation.hxx)
ot_install_header_file (AggregatedNumericalMathEvaluationImplementation.hxx)
ot_install_header_file (AggregatedNumericalMathGradientImplementation.hxx)
ot_install_header_file (AggregatedNumericalMathHessianImplementation.hxx)
ot_install_header_file (PiecewiseLinearEvaluationImplementation.hxx)
ot_install_header_file (PiecewiseHermiteEvaluationImplementation.hxx)
ot_install_header_file (ConstantNumericalMathGradientImplementation.hxx)
ot_install_header_file (ProductPolynomialEvaluationImplementation.hxx)
ot_install_header_file (QuadraticNumericalMathEvaluationImplementation.hxx)
ot_install_header_file (NoNumericalMathGradientImplementation.hxx)
ot_install_header_file (ProductNumericalMathEvaluationImplementation.hxx)
ot_install_header_file (NoNumericalMathHessianImplementation.hxx)
ot_install_header_file (IndicatorNumericalMathEvaluationImplementation.hxx)
ot_install_header_file (MethodBoundNumericalMathEvaluationImplementation.hxx)
ot_install_header_file (ComposedNumericalMathHessianImplementation.hxx)
ot_install_header_file (OTFunc.hxx)
ot_install_header_file (NumericalMathHessianImplementation.hxx)
ot_install_header_file (ProductNumericalMathFunction.hxx)
ot_install_header_file (LinearNumericalMathGradientImplementation.hxx)
ot_install_header_file (LinearNumericalMathEvaluationImplementation.hxx)
ot_install_header_file (XMLTags.hxx)
ot_install_header_file (NoNumericalMathEvaluationImplementation.hxx)
ot_install_header_file (ConstantNumericalMathHessianImplementation.hxx)
ot_install_header_file (LinearNumericalMathFunction.hxx)
ot_install_header_file (QuadraticNumericalMathFunction.hxx)
ot_install_header_file (UniVariatePolynomial.hxx)
ot_install_header_file (ProductNumericalMathGradientImplementation.hxx)
ot_install_header_file (ComposedNumericalMathEvaluationImplementation.hxx)
ot_install_header_file (NumericalMathGradientImplementation.hxx)
ot_install_header_file (NumericalMathEvaluationImplementation.hxx)
ot_install_header_file (ComposedNumericalMathGradientImplementation.hxx)
ot_install_header_file (DualLinearCombinationEvaluationImplementation.hxx)
ot_install_header_file (DualLinearCombinationGradientImplementation.hxx)
ot_install_header_file (DualLinearCombinationHessianImplementation.hxx)
ot_install_header_file (ExpertMixture.hxx)
ot_install_header_file (LinearCombinationEvaluationImplementation.hxx)
ot_install_header_file (LinearCombinationGradientImplementation.hxx)
ot_install_header_file (LinearCombinationHessianImplementation.hxx)
ot_install_header_file (ComposedNumericalMathFunction.hxx)
ot_install_header_file (UniVariatePolynomialImplementation.hxx)
ot_install_header_file (NumericalMathFunctionImplementation.hxx)
ot_install_header_file (NumericalMathFunction.hxx)
ot_install_header_file (DynamicalFunctionImplementation.hxx)
ot_install_header_file (DynamicalFunction.hxx)
ot_install_header_file (SpatialFunction.hxx)
ot_install_header_file (TemporalFunction.hxx)
ot_install_header_file (ProductNumericalMathHessianImplementation.hxx)
ot_install_header_file (DatabaseNumericalMathEvaluationImplementation.hxx)
ot_install_header_file (BasisImplementation.hxx)
ot_install_header_file (Basis.hxx)
ot_install_header_file (FiniteBasis.hxx)
ot_install_header_file (BasisSequenceImplementation.hxx)
ot_install_header_file (BasisSequence.hxx)
ot_install_header_file (BasisSequenceFactoryImplementation.hxx)
ot_install_header_file (BasisSequenceFactory.hxx)
ot_install_header_file (LAR.hxx)
ot_install_header_file (BoxCoxEvaluationImplementation.hxx)
ot_install_header_file (BoxCoxGradientImplementation.hxx)
ot_install_header_file (BoxCoxHessianImplementation.hxx)
ot_install_header_file (BoxCoxTransform.hxx)
ot_install_header_file (InverseBoxCoxEvaluationImplementation.hxx)
ot_install_header_file (InverseBoxCoxGradientImplementation.hxx)
ot_install_header_file (InverseBoxCoxHessianImplementation.hxx)
ot_install_header_file (InverseBoxCoxTransform.hxx)
ot_install_header_file (TrendEvaluationImplementation.hxx)
ot_install_header_file (TrendTransform.hxx)
ot_install_header_file (InverseTrendEvaluationImplementation.hxx)
ot_install_header_file (InverseTrendTransform.hxx)
ot_install_header_file (BasisFactory.hxx)
ot_install_header_file (ConstantBasisFactory.hxx)
ot_install_header_file (LinearBasisFactory.hxx)
ot_install_header_file (QuadraticBasisFactory.hxx)
ot_install_header_file (ParametricEvaluationImplementation.hxx)
ot_install_header_file (ParametricGradientImplementation.hxx)
ot_install_header_file (ParametricHessianImplementation.hxx)
ot_install_header_file (P1LagrangeEvaluationImplementation.hxx)
ot_install_header_file (FunctionalBasisImplementation.hxx)
ot_install_header_file (FunctionalBasis.hxx)

# Recurse in subdirectories
add_subdirectory (SpecFunc)

=== lib/src/Base/Geom/CMakeLists.txt ===
#                                               -*- cmake -*-

# Register current directory files
ot_add_current_dir_to_include_dirs ()

ot_add_source_file (DomainImplementation.cxx)
ot_add_source_file (Domain.cxx)
ot_add_source_file (Interval.cxx)
ot_add_source_file (IntervalMesher.cxx)
ot_add_source_file (LevelSet.cxx)
ot_add_source_file (Mesh.cxx)
ot_add_source_file (MeshFactory.cxx)
ot_add_source_file (MeshFactoryImplementation.cxx)
ot_add_source_file (RegularGrid.cxx)

ot_install_header_file (OTGeom.hxx)
ot_install_header_file (DomainImplementation.hxx)
ot_install_header_file (Domain.hxx)
ot_install_header_file (Interval.hxx)
ot_install_header_file (IntervalMesher.hxx)
ot_install_header_file (LevelSet.hxx)
ot_install_header_file (Mesh.hxx)
ot_install_header_file (MeshFactory.hxx)
ot_install_header_file (MeshFactoryImplementation.hxx)
ot_install_header_file (RegularGrid.hxx)

=== debian/changelog ===
openturns (1.7-3ubuntu1) artful; urgency=medium

  * Build with -ffloat-store on i386.

 -- Steve Langasek <steve.langasek@ubuntu.com>  Mon, 14 Aug 2017 14:14:01 -0700

openturns (1.7-3build2) artful; urgency=medium

  * No-change rebuild for GCC 7 abi mangling change.

 -- Matthias Klose <doko@ubuntu.com>  Mon, 07 Aug 2017 15:21:21 +0000

openturns (1.7-3build1) artful; urgency=medium

  * No-change rebuild to build with python3.6.

 -- Matthias Klose <doko@ubuntu.com>  Mon, 24 Jul 2017 14:08:10 +0000

openturns (1.7-3) unstable; urgency=medium

  * Team upload.
  * Keep swig files only in libopenturns-dev, not also in python-openturns-dev.
    Closes: #826688

 -- Mattia Rizzolo <mattia@debian.org>  Tue, 21 Jun 2016 08:16:28 +0000

openturns (1.7-2) unstable; urgency=medium

  * Team upload.
  * Upload to unstable.
  * debian/control: Use https in Vcs-* fields.

 -- Mattia Rizzolo <mattia@debian.org>  Mon, 20 Jun 2016 19:34:28 +0000

openturns (1.7-1) experimental; urgency=medium

  [ Julien Schueller ]
  * New upstream release.

  [ Denis Barbier ]
  * debian/docs: Remove ChangeLog, this file is already copied
    by dh_installchangelogs.

 -- Denis Barbier <barbier@debian.org>  Sun, 05 Jun 2016 17:54:45 +0100

openturns (1.7~rc1-1) experimental; urgency=low

  [ Julien Schueller ]
  * New upstream pre-release.

 -- Denis Barbier <barbier@debian.org>  Thu, 10 Dec 2015 18:14:47 +0100

openturns (1.6-1) experimental; urgency=low

  [ Julien Schueller ]
  * New upstream release.

 -- Denis Barbier <barbier@debian.org>  Thu, 13 Aug 2015 18:14:47 +0200

openturns (1.6~rc1-1) experimental; urgency=low

  [ Julien Schueller ]
  * New upstream pre-release.

 -- Denis Barbier <barbier@debian.org>  Mon, 16 Jun 2015 16:34:47 +0100

=== debian/control ===
Source: openturns
Section: science
Priority: extra
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
XSBC-Original-Maintainer: Debian Science Maintainers <debian-science-maintainers@lists.alioth.debian.org>
Uploaders: Christophe Prud'homme <prudhomm@debian.org>, Denis Barbier <barbier@debian.org>
Build-Depends: debhelper (>= 8), quilt, gfortran, bison, flex, cmake, bc,
 libmuparser-dev, libxml2-dev, liblapack-dev, libblas-dev,
 libboost-math-dev, libhmat-oss-dev, libnlopt-dev,
 libtbb-dev [i386 amd64 ia64],
 r-base-core, python-dev, python3-dev, swig (>= 2.0.9)
Standards-Version: 3.9.6
Homepage: http://www.openturns.org/
Vcs-Browser: https://anonscm.debian.org/git/debian-science/packages/openturns.git
Vcs-Git: https://anonscm.debian.org/git/debian-science/packages/openturns.git
X-Python-Version: current
X-Python3-Version: current

Package: libopenturns0.8
Section: libs
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Suggests: python-openturns, r-base-core, ghostscript, r-other-rot (= ${binary:Version})
Replaces: openturns-wrapper
Breaks: openturns-wrapper
Description: dynamic libraries for OpenTURNS
 OpenTURNS is a powerful and generic tool to treat and quantify
 uncertainties in numerical simulations in design, optimization and
 control. It allows both sensitivity and reliability analysis studies:
  * define the outputs of interest and decision criteria;
  * quantify and model the source of uncertainties;
  * propagate uncertainties and/or analyse sensitivity
  * rank the sources of uncertainty
 .
 OpenTURNS is a large project with more than 300 C++ classes which
 uses well known and supported software such as R for the statistical
 methods and BLAS/LAPACK for the linear algebra.
 .
 This package provides the dynamic libraries.
 .
 The library implements almost all the treatments of uncertainty that
 OpenTURNS can provide. It is designed to be linked against any user
 specific application, or with either the textual front-end (see
 python-openturns or python3-openturns packages).
 .
 The main function of that library is giving to specific applications
 all the functionalities needed to treat uncertainties in
 studies. Targeted users are all engineers who want to introduce the
 probabilistic dimension in their so far deterministic studies.

Package: libopenturns-dev
Section: libdevel
Architecture: any
Depends: ${misc:Depends}, libopenturns0.8 (= ${binary:Version}),
  libmuparser-dev, libxml2-dev, liblapack-dev, libblas-dev, libtbb-dev [i386 amd64 ia64], libhmat-oss-dev, libnlopt-dev
Replaces: python-openturns-dev (<< 1.5-2)
Breaks: python-openturns-dev (<< 1.5-2)
Description: headers and development libraries for OpenTURNS
 OpenTURNS is a powerful and generic tool to treat and quantify
 uncertainties in numerical simulations in design, optimization and
 control. It allows both sensitivity and reliability analysis studies:
  * defining the outputs of interest and decision criterion;
  * quantify and model the source of uncertainties;
  * propagate uncertainties and/or analyse sensitivity and
  * rank the sources of uncertainty
 .
 OpenTURNS is a large project with more than 300 C++ classes which
 uses well known and supported software such as R for the statistical
 methods and BLAS/LAPACK for the linear algebra.
 .
 This package provides the OpenTURNS headers should be used if one
 wants to link its application against the library.

Package: libopenturns0.8-dbg
Section: debug
Architecture: any
Depends: libopenturns0.8 (= ${binary:Version}), ${misc:Depends}
Description: debug symbols for OpenTURNS
 OpenTURNS is a powerful and generic tool to treat and quantify
 uncertainties in numerical simulations in design, optimization and
 control. It allows both sensitivity and reliability analysis studies:
  * defining the outputs of interest and decision criterion;
  * quantify and model the source of uncertainties;
  * propagate uncertainties and/or analyse sensitivity and
  * rank the sources of uncertainty
 .
 OpenTURNS is a large project with more than 300 C++ classes which
 uses well known and supported software such as R for the statistical
 methods and BLAS/LAPACK for the linear algebra.
 .
 This package provides the debug symbols of the OpenTurns libraries to
 help with debugging either your applications or OpenTURNS

Package: python-openturns
Section: python
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, libopenturns0.8 (= ${binary:Version}), ${python:Depends}
Provides: ${python:Provides}
Suggests: python-matplotlib, python-scipy
Description: Python front-end of OpenTURNS (aka TUI)
 OpenTURNS is a powerful and generic tool to treat and quantify
 uncertainties in numerical simulations in design, optimization and
 control. It allows both sensitivity and reliability analysis studies:
  * defining the outputs of interest and decision criterion;
  * quantify and model the source of uncertainties;
  * propagate uncertainties and/or analyse sensitivity and
  * rank the sources of uncertainty
 .
 OpenTURNS is a large project with more than 300 C++ classes which
 uses well known and supported software such as R for the statistical
 methods and BLAS/LAPACK for the linear algebra.
 .
 This package provides a textual user interface that gives access to
 all the functionalities provided by the OpenTURNS library.

Package: python3-openturns
Section: python
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, libopenturns0.8 (= ${binary:Version}), ${python3:Depends}
Provides: ${python3:Provides}
Suggests: python3-matplotlib, python3-scipy
Description: Python3 front-end of OpenTURNS (aka TUI)
 OpenTURNS is a powerful and generic tool to treat and quantify
 uncertainties in numerical simulations in design, optimization and
 control. It allows both sensitivity and reliability analysis studies:
  * defining the outputs of interest and decision criterion;
  * quantify and model the source of uncertainties;
  * propagate uncertainties and/or analyse sensitivity and
  * rank the sources of uncertainty
 .
 OpenTURNS is a large project with more than 300 C++ classes which
 uses well known and supported software such as R for the statistical
 methods and BLAS/LAPACK for the linear algebra.
 .
 This package provides a textual user interface with Python3 that gives
 access to all the functionalities provided by the OpenTURNS library.

Package: python-openturns-dev
Section: oldlibs
Architecture: all
Depends: ${misc:Depends}, libopenturns-dev
Description: Python front-end of OpenTURNS (transitional package)
 OpenTURNS is a powerful and generic tool to treat and quantify
 uncertainties in numerical simulations in design, optimization and
 control. It allows both sensitivity and reliability analysis studies:
  * defining the outputs of interest and decision criterion;
  * quantify and model the source of uncertainties;
  * propagate uncertainties and/or analyse sensitivity and
  * rank the sources of uncertainty
 .
 OpenTURNS is a large project with more than 300 C++ classes which
 uses well known and supported software such as R for the statistical
 methods and BLAS/LAPACK for the linear algebra.
 .
 This is a transitional package, python-openturns-dev has been
 merged into libopenturns-dev.

Package: r-other-rot
Section: gnu-r
Architecture: any
Depends: ${misc:Depends}, r-base-core
Description: GNU R package of few tools needed by OpenTURNS
 OpenTURNS is a powerful and generic tool to treat and quantify
 uncertainties in numerical simulations in design, optimization and
 control. It allows both sensitivity and reliability analysis studies:
  * defining the outputs of interest and decision criterion;
  * quantify and model the source of uncertainties;
  * propagate uncertainties and/or analyse sensitivity and
  * rank the sources of uncertainty
 .
 OpenTURNS is a large project with more than 300 C++ classes which
 uses well known and supported software such as R for the statistical
 methods and BLAS/LAPACK for the linear algebra.
 .
 This package provides R files needed by some OpenTURNS objects.

Package: openturns-examples
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, python, python-openturns (= ${binary:Version}), libopenturns-dev
Replaces: openturns-wrapper
Breaks: openturns-wrapper
Description: examples of OpenTURNS functionalities
 OpenTURNS is a powerful and generic tool to treat and quantify
 uncertainties in numerical simulations in design, optimization and
 control. It allows both sensitivity and reliability analysis studies:
  * defining the outputs of interest and decision criterion;
  * quantify and model the source of uncertainties;
  * propagate uncertainties and/or analyse sensitivity and
  * rank the sources of uncertainty
 .
 OpenTURNS is a large project with more than 300 C++ classes which
 uses well known and supported software such as R for the statistical
 methods and BLAS/LAPACK for the linear algebra.
 .
 This package provides examples which are written either in C++ or in
 Python.
 .
 They are primarly used as validation tests for the whole
 platform but they can also be seen as tutorials for
 beginners.

Package: openturns-validation
Section: science
Architecture: all
Depends: ${misc:Depends}
Description: validation files for OpenTURNS
 OpenTURNS is a powerful and generic tool to treat and quantify
 uncertainties in numerical simulations in design, optimization and
 control. It allows both sensitivity and reliability analysis studies:
  * defining the outputs of interest and decision criterion;
  * quantify and model the source of uncertainties;
  * propagate uncertainties and/or analyse sensitivity and
  * rank the sources of uncertainty
 .
 OpenTURNS is a large project with more than 300 C++ classes which
 uses well known and supported software such as R for the statistical
 methods and BLAS/LAPACK for the linear algebra.
 .
 This package includes many maple input files that validates the
 results and the algorithms of OpenTURNS in a mathematical sense.

=== debian/rules ===
#!/usr/bin/make -f

ifeq ($(findstring parallel=,$(DEB_BUILD_OPTIONS)),)
	export DEB_BUILD_OPTIONS+=parallel=$(shell getconf _NPROCESSORS_ONLN)
endif
$(info DEB_BUILD_OPTIONS:$(origin DEB_BUILD_OPTIONS)=$(DEB_BUILD_OPTIONS))

ifneq (,$(filter parallel=%,$(DEB_BUILD_OPTIONS)))
	NUMJOBS = $(patsubst parallel=%,%,$(filter parallel=%,$(DEB_BUILD_OPTIONS)))
	test_makeflags = -j$(NUMJOBS)
endif

cppflags := $(shell dpkg-buildflags --get CPPFLAGS)
cflags := $(shell dpkg-buildflags --get CFLAGS) $(cppflags)
cxxflags := $(shell dpkg-buildflags --get CXXFLAGS) $(cppflags)
fflags := $(shell dpkg-buildflags --get FFLAGS)
ldflags := $(shell dpkg-buildflags --get LDFLAGS)
ldflags += -Wl,--as-needed

ifeq ($(shell dpkg --print-architecture),armel)
    cflags := $(subst -O2,-O1,$(cflags))
    cxxflags := $(subst -O2,-O1,$(cxxflags))
    fflags := $(subst -O2,-O1,$(fflags))
endif
ifeq ($(shell dpkg --print-architecture),armhf)
    cflags := $(subst -O2,-O1,$(cflags))
    cxxflags := $(subst -O2,-O1,$(cxxflags))
    fflags := $(subst -O2,-O1,$(fflags))
endif
ifneq (,$(findstring $(shell dpkg-architecture -qDEB_HOST_ARCH), i386 kfreebsd-i386 hurd-i386))
    cflags += -O0 -ffloat-store
    cxxflags += -ffloat-store
endif
ifneq (,$(findstring $(shell dpkg-architecture -qDEB_HOST_ARCH), i386 amd64 ia64))
    with_tbb := -DUSE_TBB:BOOL=ON
else
    with_tbb := -DUSE_TBB:BOOL=OFF
endif

debRlib := $(CURDIR)/debian/tmp/usr/lib/R/site-library
export R_LIBS=$(debRlib)
PYVER = $(shell pyversions -d)
PY3VER = $(shell py3versions -d)
PYALL = $(PYVER) $(PY3VER)

%:
ifneq (,$(findstring $(shell dpkg-architecture -qDEB_HOST_ARCH), mips mipsel))
	$(error This package requires more than 1GB RAM; do not build on mips/mipsel)
endif
	dh $@ --buildsystem=cmake --with python2,python3 --with quilt --parallel

debian/tmp/usr/lib/R/site-library/rot:
	-mkdir -p $(debRlib)
	R CMD INSTALL --library=$(debRlib) utils/rot_1.4.6.tar.gz

override_dh_auto_configure: debian/tmp/usr/lib/R/site-library/rot $(PYALL:python%=cmake-configure-%) \

cmake-configure-%:
	dh_auto_configure -Bbuild-python$* -- \
            $(with_tbb) \
            -DUSE_SPHINX:BOOL=OFF \
            -DCMAKE_CXX_COMPILER:FILEPATH=/usr/bin/g++ \
            -DCMAKE_C_COMPILER:FILEPATH=/usr/bin/gcc \
            -DCMAKE_BUILD_TYPE:STRING=RelWithDebInfo \
            -DCMAKE_C_FLAGS_RELWITHDEBINFO:STRING='$(cflags)' \
            -DCMAKE_CXX_FLAGS_RELWITHDEBINFO:STRING='$(cxxflags)' \
            -DCMAKE_EXE_LINKER_FLAGS_RELWITHDEBINFO:STRING='$(ldflags)' \
            -DCMAKE_MODULE_LINKER_FLAGS_RELWITHDEBINFO:STRING='$(ldflags)' \
            -DCMAKE_SHARED_LINKER_FLAGS_RELWITHDEBINFO:STRING='$(ldflags)' \
            -DCMAKE_SKIP_INSTALL_RPATH:BOOL=ON \
            -DCMAKE_INSTALL_PREFIX:PATH=/usr \
            -DCMAKE_INSTALL_LIBDIR:PATH=/usr/lib \
            -DLIB_SOVERSION=0.8 \
            -DLIB_VERSION=0.8.0 \
            -DOPENTURNS_SYSCONFIG_PATH:PATH=/etc/openturns-1.7 \
            -DINSTALL_DESTDIR:PATH=$(CURDIR)/debian/tmp \
            -DLINK_PYTHON_LIBRARY:BOOL=OFF \
            -DPYTHON_EXECUTABLE:FILEPATH=/usr/bin/python$* \
            -DPYTHON_INCLUDE_DIR:PATH=$$(python$*-config --includes | sed -e 's/ .*//' -e 's/^-I//') \
            -DPYTHON_INCLUDE_DIR2:PATH=$$(python$*-config --includes | sed -e 's/ .*//' -e 's/^-I//') \
            -DPYTHON_LIBRARY:PATH=$$(python$*-config --ldflags | sed -e 's/ .*//' -e 's/^-L//')/libpython$*.so

override_dh_auto_build: $(PYALL:python%=cmake-build-%)

cmake-build-%:
	$(MAKE) $(test_makeflags) -C build-python$*/lib
	$(MAKE) -j1 -C build-python$*/python
	$(MAKE) $(test_makeflags) -C build-python$*

override_dh_auto_install: debian/tmp/usr/lib/R/site-library/rot $(PYALL:python%=cmake-install-%)

cmake-install-%:
	dh_auto_install -Bbuild-python$*
	mkdir -p debian/libopenturns0.8-dbg/usr/lib/debug/usr/lib
ifeq (,$(findstring nocheck,$(DEB_BUILD_OPTIONS)))
	LD_LIBRARY_PATH=$${LD_LIBRARY_PATH:+$${LD_LIBRARY_PATH}:}$(CURDIR)/debian/tmp/usr/lib \
	  CTEST_OUTPUT_ON_FAILURE=1 \
	  R_LIBS_SITE=$(CURDIR)/debian/tmp/usr/lib/R/site-library \
	  $(MAKE) $(test_makeflags) -C build-python$* test ARGS="$(test_makeflags) -R pyinstallcheck"
endif

override_dh_makeshlibs:
	dh_makeshlibs -Xpyshared

override_dh_strip:
	dh_strip -plibopenturns0.8 --dbg-package=libopenturns0.8-dbg
	dh_strip

override_dh_python2:
	dh_python2 -p python-openturns

override_dh_python3:
	dh_python3 -p python3-openturns

override_dh_compress:
	dh_compress -X.pdf -X.git -X.py

override_dh_auto_test: $(PYALL:python%=cmake-test-%)

cmake-test-%:
	# 'make test' does not build binary tests
ifeq (,$(findstring nocheck,$(DEB_BUILD_OPTIONS)))
	$(MAKE) $(test_makeflags) -C build-python$* tests
	LD_LIBRARY_PATH=$${LD_LIBRARY_PATH:+$${LD_LIBRARY_PATH}:}$(CURDIR)/debian/tmp/usr/lib \
	  CTEST_OUTPUT_ON_FAILURE=1 \
	  $(MAKE) -C build-python$* test ARGS="$(test_makeflags) -R cppcheck"
endif

get-orig-source:
	uscan --force-download --verbose
	mv ../openturn*.tar.[gzbz2]* ../tarballs
